/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * M68k Disassembler                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/MC/SubtargetFeature.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static const uint8_t DecoderTable80[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 0, 45, 6, 0, // Skip to: 1589
/* 8 */       MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11 */      MCD::OPC_FilterValue, 0, 65, 0, 0, // Skip to: 81
/* 16 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 19 */      MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 35
/* 24 */      MCD::OPC_CheckField, 24, 8, 0, 131, 48, 0, // Skip to: 12450
/* 31 */      MCD::OPC_Decode, 169, 3, 0, // Opcode: BTST32di
/* 35 */      MCD::OPC_FilterValue, 5, 18, 0, 0, // Skip to: 58
/* 40 */      MCD::OPC_CheckField, 24, 8, 0, 115, 48, 0, // Skip to: 12450
/* 47 */      MCD::OPC_CheckField, 3, 1, 0, 108, 48, 0, // Skip to: 12450
/* 54 */      MCD::OPC_Decode, 236, 8, 1, // Opcode: XOR8di
/* 58 */      MCD::OPC_FilterValue, 6, 99, 48, 0, // Skip to: 12450
/* 63 */      MCD::OPC_CheckField, 24, 8, 0, 92, 48, 0, // Skip to: 12450
/* 70 */      MCD::OPC_CheckField, 3, 1, 0, 85, 48, 0, // Skip to: 12450
/* 77 */      MCD::OPC_Decode, 245, 3, 2, // Opcode: CMP8di
/* 81 */      MCD::OPC_FilterValue, 1, 158, 0, 0, // Skip to: 244
/* 86 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 89 */      MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 112
/* 94 */      MCD::OPC_CheckField, 24, 8, 0, 61, 48, 0, // Skip to: 12450
/* 101 */     MCD::OPC_CheckField, 3, 1, 0, 54, 48, 0, // Skip to: 12450
/* 108 */     MCD::OPC_Decode, 230, 7, 3, // Opcode: OR8ji
/* 112 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 135
/* 117 */     MCD::OPC_CheckField, 24, 8, 0, 38, 48, 0, // Skip to: 12450
/* 124 */     MCD::OPC_CheckField, 3, 1, 0, 31, 48, 0, // Skip to: 12450
/* 131 */     MCD::OPC_Decode, 157, 3, 3, // Opcode: AND8ji
/* 135 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 158
/* 140 */     MCD::OPC_CheckField, 24, 8, 0, 15, 48, 0, // Skip to: 12450
/* 147 */     MCD::OPC_CheckField, 3, 1, 0, 8, 48, 0, // Skip to: 12450
/* 154 */     MCD::OPC_Decode, 221, 8, 3, // Opcode: SUB8ji
/* 158 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 181
/* 163 */     MCD::OPC_CheckField, 24, 8, 0, 248, 47, 0, // Skip to: 12450
/* 170 */     MCD::OPC_CheckField, 3, 1, 0, 241, 47, 0, // Skip to: 12450
/* 177 */     MCD::OPC_Decode, 241, 2, 3, // Opcode: ADD8ji
/* 181 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 221
/* 186 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 189 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 205
/* 194 */     MCD::OPC_CheckField, 24, 8, 0, 217, 47, 0, // Skip to: 12450
/* 201 */     MCD::OPC_Decode, 175, 3, 3, // Opcode: BTST8ji
/* 205 */     MCD::OPC_FilterValue, 1, 208, 47, 0, // Skip to: 12450
/* 210 */     MCD::OPC_CheckField, 24, 8, 0, 201, 47, 0, // Skip to: 12450
/* 217 */     MCD::OPC_Decode, 179, 3, 3, // Opcode: BTST8oi
/* 221 */     MCD::OPC_FilterValue, 6, 192, 47, 0, // Skip to: 12450
/* 226 */     MCD::OPC_CheckField, 24, 8, 0, 185, 47, 0, // Skip to: 12450
/* 233 */     MCD::OPC_CheckField, 3, 1, 0, 178, 47, 0, // Skip to: 12450
/* 240 */     MCD::OPC_Decode, 251, 3, 4, // Opcode: CMP8ji
/* 244 */     MCD::OPC_FilterValue, 2, 158, 0, 0, // Skip to: 407
/* 249 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 252 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 275
/* 257 */     MCD::OPC_CheckField, 24, 8, 0, 154, 47, 0, // Skip to: 12450
/* 264 */     MCD::OPC_CheckField, 3, 1, 1, 147, 47, 0, // Skip to: 12450
/* 271 */     MCD::OPC_Decode, 232, 7, 5, // Opcode: OR8pi
/* 275 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 298
/* 280 */     MCD::OPC_CheckField, 24, 8, 0, 131, 47, 0, // Skip to: 12450
/* 287 */     MCD::OPC_CheckField, 3, 1, 1, 124, 47, 0, // Skip to: 12450
/* 294 */     MCD::OPC_Decode, 159, 3, 5, // Opcode: AND8pi
/* 298 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 321
/* 303 */     MCD::OPC_CheckField, 24, 8, 0, 108, 47, 0, // Skip to: 12450
/* 310 */     MCD::OPC_CheckField, 3, 1, 1, 101, 47, 0, // Skip to: 12450
/* 317 */     MCD::OPC_Decode, 223, 8, 5, // Opcode: SUB8pi
/* 321 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 344
/* 326 */     MCD::OPC_CheckField, 24, 8, 0, 85, 47, 0, // Skip to: 12450
/* 333 */     MCD::OPC_CheckField, 3, 1, 1, 78, 47, 0, // Skip to: 12450
/* 340 */     MCD::OPC_Decode, 243, 2, 5, // Opcode: ADD8pi
/* 344 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 384
/* 349 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 352 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 368
/* 357 */     MCD::OPC_CheckField, 24, 8, 0, 54, 47, 0, // Skip to: 12450
/* 364 */     MCD::OPC_Decode, 171, 3, 3, // Opcode: BTST8ei
/* 368 */     MCD::OPC_FilterValue, 1, 45, 47, 0, // Skip to: 12450
/* 373 */     MCD::OPC_CheckField, 24, 8, 0, 38, 47, 0, // Skip to: 12450
/* 380 */     MCD::OPC_Decode, 181, 3, 5, // Opcode: BTST8pi
/* 384 */     MCD::OPC_FilterValue, 6, 29, 47, 0, // Skip to: 12450
/* 389 */     MCD::OPC_CheckField, 24, 8, 0, 22, 47, 0, // Skip to: 12450
/* 396 */     MCD::OPC_CheckField, 3, 1, 1, 15, 47, 0, // Skip to: 12450
/* 403 */     MCD::OPC_Decode, 253, 3, 6, // Opcode: CMP8pi
/* 407 */     MCD::OPC_FilterValue, 3, 39, 1, 0, // Skip to: 707
/* 412 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 415 */     MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 445
/* 420 */     MCD::OPC_CheckField, 40, 4, 8, 247, 46, 0, // Skip to: 12450
/* 427 */     MCD::OPC_CheckField, 24, 8, 0, 240, 46, 0, // Skip to: 12450
/* 434 */     MCD::OPC_CheckField, 3, 1, 0, 233, 46, 0, // Skip to: 12450
/* 441 */     MCD::OPC_Decode, 228, 7, 7, // Opcode: OR8fi
/* 445 */     MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 475
/* 450 */     MCD::OPC_CheckField, 40, 4, 8, 217, 46, 0, // Skip to: 12450
/* 457 */     MCD::OPC_CheckField, 24, 8, 0, 210, 46, 0, // Skip to: 12450
/* 464 */     MCD::OPC_CheckField, 3, 1, 0, 203, 46, 0, // Skip to: 12450
/* 471 */     MCD::OPC_Decode, 155, 3, 7, // Opcode: AND8fi
/* 475 */     MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 505
/* 480 */     MCD::OPC_CheckField, 40, 4, 8, 187, 46, 0, // Skip to: 12450
/* 487 */     MCD::OPC_CheckField, 24, 8, 0, 180, 46, 0, // Skip to: 12450
/* 494 */     MCD::OPC_CheckField, 3, 1, 0, 173, 46, 0, // Skip to: 12450
/* 501 */     MCD::OPC_Decode, 219, 8, 7, // Opcode: SUB8fi
/* 505 */     MCD::OPC_FilterValue, 3, 25, 0, 0, // Skip to: 535
/* 510 */     MCD::OPC_CheckField, 40, 4, 8, 157, 46, 0, // Skip to: 12450
/* 517 */     MCD::OPC_CheckField, 24, 8, 0, 150, 46, 0, // Skip to: 12450
/* 524 */     MCD::OPC_CheckField, 3, 1, 0, 143, 46, 0, // Skip to: 12450
/* 531 */     MCD::OPC_Decode, 239, 2, 7, // Opcode: ADD8fi
/* 535 */     MCD::OPC_FilterValue, 4, 73, 0, 0, // Skip to: 613
/* 540 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 543 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 566
/* 548 */     MCD::OPC_CheckField, 40, 4, 8, 119, 46, 0, // Skip to: 12450
/* 555 */     MCD::OPC_CheckField, 24, 8, 0, 112, 46, 0, // Skip to: 12450
/* 562 */     MCD::OPC_Decode, 173, 3, 7, // Opcode: BTST8fi
/* 566 */     MCD::OPC_FilterValue, 1, 103, 46, 0, // Skip to: 12450
/* 571 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 574 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 590
/* 579 */     MCD::OPC_CheckField, 24, 8, 0, 88, 46, 0, // Skip to: 12450
/* 586 */     MCD::OPC_Decode, 183, 3, 8, // Opcode: BTST8qi
/* 590 */     MCD::OPC_FilterValue, 3, 79, 46, 0, // Skip to: 12450
/* 595 */     MCD::OPC_CheckField, 40, 4, 8, 72, 46, 0, // Skip to: 12450
/* 602 */     MCD::OPC_CheckField, 24, 8, 0, 65, 46, 0, // Skip to: 12450
/* 609 */     MCD::OPC_Decode, 177, 3, 9, // Opcode: BTST8ki
/* 613 */     MCD::OPC_FilterValue, 6, 56, 46, 0, // Skip to: 12450
/* 618 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 621 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 644
/* 626 */     MCD::OPC_CheckField, 40, 4, 8, 41, 46, 0, // Skip to: 12450
/* 633 */     MCD::OPC_CheckField, 24, 8, 0, 34, 46, 0, // Skip to: 12450
/* 640 */     MCD::OPC_Decode, 250, 3, 10, // Opcode: CMP8fi
/* 644 */     MCD::OPC_FilterValue, 1, 25, 46, 0, // Skip to: 12450
/* 649 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 652 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 668
/* 657 */     MCD::OPC_CheckField, 24, 8, 0, 10, 46, 0, // Skip to: 12450
/* 664 */     MCD::OPC_Decode, 242, 3, 11, // Opcode: CMP8bi
/* 668 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 684
/* 673 */     MCD::OPC_CheckField, 24, 8, 0, 250, 45, 0, // Skip to: 12450
/* 680 */     MCD::OPC_Decode, 254, 3, 12, // Opcode: CMP8qi
/* 684 */     MCD::OPC_FilterValue, 3, 241, 45, 0, // Skip to: 12450
/* 689 */     MCD::OPC_CheckField, 40, 4, 8, 234, 45, 0, // Skip to: 12450
/* 696 */     MCD::OPC_CheckField, 24, 8, 0, 227, 45, 0, // Skip to: 12450
/* 703 */     MCD::OPC_Decode, 252, 3, 13, // Opcode: CMP8ki
/* 707 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 747
/* 712 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 715 */     MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 731
/* 720 */     MCD::OPC_CheckField, 3, 1, 0, 203, 45, 0, // Skip to: 12450
/* 727 */     MCD::OPC_Decode, 232, 8, 14, // Opcode: XOR16di
/* 731 */     MCD::OPC_FilterValue, 6, 194, 45, 0, // Skip to: 12450
/* 736 */     MCD::OPC_CheckField, 3, 1, 0, 187, 45, 0, // Skip to: 12450
/* 743 */     MCD::OPC_Decode, 218, 3, 15, // Opcode: CMP16di
/* 747 */     MCD::OPC_FilterValue, 5, 83, 0, 0, // Skip to: 835
/* 752 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 755 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 771
/* 760 */     MCD::OPC_CheckField, 3, 1, 0, 163, 45, 0, // Skip to: 12450
/* 767 */     MCD::OPC_Decode, 203, 7, 16, // Opcode: OR16ji
/* 771 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 787
/* 776 */     MCD::OPC_CheckField, 3, 1, 0, 147, 45, 0, // Skip to: 12450
/* 783 */     MCD::OPC_Decode, 130, 3, 16, // Opcode: AND16ji
/* 787 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 803
/* 792 */     MCD::OPC_CheckField, 3, 1, 0, 131, 45, 0, // Skip to: 12450
/* 799 */     MCD::OPC_Decode, 187, 8, 16, // Opcode: SUB16ji
/* 803 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 819
/* 808 */     MCD::OPC_CheckField, 3, 1, 0, 115, 45, 0, // Skip to: 12450
/* 815 */     MCD::OPC_Decode, 207, 2, 16, // Opcode: ADD16ji
/* 819 */     MCD::OPC_FilterValue, 6, 106, 45, 0, // Skip to: 12450
/* 824 */     MCD::OPC_CheckField, 3, 1, 0, 99, 45, 0, // Skip to: 12450
/* 831 */     MCD::OPC_Decode, 225, 3, 17, // Opcode: CMP16ji
/* 835 */     MCD::OPC_FilterValue, 6, 83, 0, 0, // Skip to: 923
/* 840 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 843 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 859
/* 848 */     MCD::OPC_CheckField, 3, 1, 1, 75, 45, 0, // Skip to: 12450
/* 855 */     MCD::OPC_Decode, 205, 7, 18, // Opcode: OR16pi
/* 859 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 875
/* 864 */     MCD::OPC_CheckField, 3, 1, 1, 59, 45, 0, // Skip to: 12450
/* 871 */     MCD::OPC_Decode, 132, 3, 18, // Opcode: AND16pi
/* 875 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 891
/* 880 */     MCD::OPC_CheckField, 3, 1, 1, 43, 45, 0, // Skip to: 12450
/* 887 */     MCD::OPC_Decode, 189, 8, 18, // Opcode: SUB16pi
/* 891 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 907
/* 896 */     MCD::OPC_CheckField, 3, 1, 1, 27, 45, 0, // Skip to: 12450
/* 903 */     MCD::OPC_Decode, 209, 2, 18, // Opcode: ADD16pi
/* 907 */     MCD::OPC_FilterValue, 6, 18, 45, 0, // Skip to: 12450
/* 912 */     MCD::OPC_CheckField, 3, 1, 1, 11, 45, 0, // Skip to: 12450
/* 919 */     MCD::OPC_Decode, 227, 3, 19, // Opcode: CMP16pi
/* 923 */     MCD::OPC_FilterValue, 7, 161, 0, 0, // Skip to: 1089
/* 928 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 931 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 954
/* 936 */     MCD::OPC_CheckField, 40, 4, 8, 243, 44, 0, // Skip to: 12450
/* 943 */     MCD::OPC_CheckField, 3, 1, 0, 236, 44, 0, // Skip to: 12450
/* 950 */     MCD::OPC_Decode, 201, 7, 20, // Opcode: OR16fi
/* 954 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 977
/* 959 */     MCD::OPC_CheckField, 40, 4, 8, 220, 44, 0, // Skip to: 12450
/* 966 */     MCD::OPC_CheckField, 3, 1, 0, 213, 44, 0, // Skip to: 12450
/* 973 */     MCD::OPC_Decode, 128, 3, 20, // Opcode: AND16fi
/* 977 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1000
/* 982 */     MCD::OPC_CheckField, 40, 4, 8, 197, 44, 0, // Skip to: 12450
/* 989 */     MCD::OPC_CheckField, 3, 1, 0, 190, 44, 0, // Skip to: 12450
/* 996 */     MCD::OPC_Decode, 185, 8, 20, // Opcode: SUB16fi
/* 1000 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1023
/* 1005 */    MCD::OPC_CheckField, 40, 4, 8, 174, 44, 0, // Skip to: 12450
/* 1012 */    MCD::OPC_CheckField, 3, 1, 0, 167, 44, 0, // Skip to: 12450
/* 1019 */    MCD::OPC_Decode, 205, 2, 20, // Opcode: ADD16fi
/* 1023 */    MCD::OPC_FilterValue, 6, 158, 44, 0, // Skip to: 12450
/* 1028 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1031 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1047
/* 1036 */    MCD::OPC_CheckField, 40, 4, 8, 143, 44, 0, // Skip to: 12450
/* 1043 */    MCD::OPC_Decode, 224, 3, 21, // Opcode: CMP16fi
/* 1047 */    MCD::OPC_FilterValue, 1, 134, 44, 0, // Skip to: 12450
/* 1052 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1055 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1064
/* 1060 */    MCD::OPC_Decode, 216, 3, 22, // Opcode: CMP16bi
/* 1064 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1073
/* 1069 */    MCD::OPC_Decode, 228, 3, 23, // Opcode: CMP16qi
/* 1073 */    MCD::OPC_FilterValue, 3, 108, 44, 0, // Skip to: 12450
/* 1078 */    MCD::OPC_CheckField, 40, 4, 8, 101, 44, 0, // Skip to: 12450
/* 1085 */    MCD::OPC_Decode, 226, 3, 24, // Opcode: CMP16ki
/* 1089 */    MCD::OPC_FilterValue, 8, 35, 0, 0, // Skip to: 1129
/* 1094 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1097 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 1113
/* 1102 */    MCD::OPC_CheckField, 3, 1, 0, 77, 44, 0, // Skip to: 12450
/* 1109 */    MCD::OPC_Decode, 234, 8, 25, // Opcode: XOR32di
/* 1113 */    MCD::OPC_FilterValue, 6, 68, 44, 0, // Skip to: 12450
/* 1118 */    MCD::OPC_CheckField, 3, 1, 0, 61, 44, 0, // Skip to: 12450
/* 1125 */    MCD::OPC_Decode, 231, 3, 26, // Opcode: CMP32di
/* 1129 */    MCD::OPC_FilterValue, 9, 83, 0, 0, // Skip to: 1217
/* 1134 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1137 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1153
/* 1142 */    MCD::OPC_CheckField, 3, 1, 0, 37, 44, 0, // Skip to: 12450
/* 1149 */    MCD::OPC_Decode, 217, 7, 27, // Opcode: OR32ji
/* 1153 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1169
/* 1158 */    MCD::OPC_CheckField, 3, 1, 0, 21, 44, 0, // Skip to: 12450
/* 1165 */    MCD::OPC_Decode, 144, 3, 27, // Opcode: AND32ji
/* 1169 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1185
/* 1174 */    MCD::OPC_CheckField, 3, 1, 0, 5, 44, 0, // Skip to: 12450
/* 1181 */    MCD::OPC_Decode, 208, 8, 27, // Opcode: SUB32ji
/* 1185 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1201
/* 1190 */    MCD::OPC_CheckField, 3, 1, 0, 245, 43, 0, // Skip to: 12450
/* 1197 */    MCD::OPC_Decode, 228, 2, 27, // Opcode: ADD32ji
/* 1201 */    MCD::OPC_FilterValue, 6, 236, 43, 0, // Skip to: 12450
/* 1206 */    MCD::OPC_CheckField, 3, 1, 0, 229, 43, 0, // Skip to: 12450
/* 1213 */    MCD::OPC_Decode, 238, 3, 28, // Opcode: CMP32ji
/* 1217 */    MCD::OPC_FilterValue, 10, 83, 0, 0, // Skip to: 1305
/* 1222 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1225 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1241
/* 1230 */    MCD::OPC_CheckField, 3, 1, 1, 205, 43, 0, // Skip to: 12450
/* 1237 */    MCD::OPC_Decode, 219, 7, 29, // Opcode: OR32pi
/* 1241 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1257
/* 1246 */    MCD::OPC_CheckField, 3, 1, 1, 189, 43, 0, // Skip to: 12450
/* 1253 */    MCD::OPC_Decode, 146, 3, 29, // Opcode: AND32pi
/* 1257 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1273
/* 1262 */    MCD::OPC_CheckField, 3, 1, 1, 173, 43, 0, // Skip to: 12450
/* 1269 */    MCD::OPC_Decode, 210, 8, 29, // Opcode: SUB32pi
/* 1273 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1289
/* 1278 */    MCD::OPC_CheckField, 3, 1, 1, 157, 43, 0, // Skip to: 12450
/* 1285 */    MCD::OPC_Decode, 230, 2, 29, // Opcode: ADD32pi
/* 1289 */    MCD::OPC_FilterValue, 6, 148, 43, 0, // Skip to: 12450
/* 1294 */    MCD::OPC_CheckField, 3, 1, 1, 141, 43, 0, // Skip to: 12450
/* 1301 */    MCD::OPC_Decode, 240, 3, 30, // Opcode: CMP32pi
/* 1305 */    MCD::OPC_FilterValue, 11, 161, 0, 0, // Skip to: 1471
/* 1310 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1313 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1336
/* 1318 */    MCD::OPC_CheckField, 56, 4, 8, 117, 43, 0, // Skip to: 12450
/* 1325 */    MCD::OPC_CheckField, 3, 1, 0, 110, 43, 0, // Skip to: 12450
/* 1332 */    MCD::OPC_Decode, 215, 7, 31, // Opcode: OR32fi
/* 1336 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 1359
/* 1341 */    MCD::OPC_CheckField, 56, 4, 8, 94, 43, 0, // Skip to: 12450
/* 1348 */    MCD::OPC_CheckField, 3, 1, 0, 87, 43, 0, // Skip to: 12450
/* 1355 */    MCD::OPC_Decode, 142, 3, 31, // Opcode: AND32fi
/* 1359 */    MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1382
/* 1364 */    MCD::OPC_CheckField, 56, 4, 8, 71, 43, 0, // Skip to: 12450
/* 1371 */    MCD::OPC_CheckField, 3, 1, 0, 64, 43, 0, // Skip to: 12450
/* 1378 */    MCD::OPC_Decode, 206, 8, 31, // Opcode: SUB32fi
/* 1382 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1405
/* 1387 */    MCD::OPC_CheckField, 56, 4, 8, 48, 43, 0, // Skip to: 12450
/* 1394 */    MCD::OPC_CheckField, 3, 1, 0, 41, 43, 0, // Skip to: 12450
/* 1401 */    MCD::OPC_Decode, 226, 2, 31, // Opcode: ADD32fi
/* 1405 */    MCD::OPC_FilterValue, 6, 32, 43, 0, // Skip to: 12450
/* 1410 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1413 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1429
/* 1418 */    MCD::OPC_CheckField, 56, 4, 8, 17, 43, 0, // Skip to: 12450
/* 1425 */    MCD::OPC_Decode, 237, 3, 32, // Opcode: CMP32fi
/* 1429 */    MCD::OPC_FilterValue, 1, 8, 43, 0, // Skip to: 12450
/* 1434 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1437 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1446
/* 1442 */    MCD::OPC_Decode, 229, 3, 33, // Opcode: CMP32bi
/* 1446 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1455
/* 1451 */    MCD::OPC_Decode, 241, 3, 34, // Opcode: CMP32qi
/* 1455 */    MCD::OPC_FilterValue, 3, 238, 42, 0, // Skip to: 12450
/* 1460 */    MCD::OPC_CheckField, 56, 4, 8, 231, 42, 0, // Skip to: 12450
/* 1467 */    MCD::OPC_Decode, 239, 3, 35, // Opcode: CMP32ki
/* 1471 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1480
/* 1476 */    MCD::OPC_Decode, 168, 3, 36, // Opcode: BTST32dd
/* 1480 */    MCD::OPC_FilterValue, 17, 21, 0, 0, // Skip to: 1506
/* 1485 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1488 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1497
/* 1493 */    MCD::OPC_Decode, 174, 3, 37, // Opcode: BTST8jd
/* 1497 */    MCD::OPC_FilterValue, 1, 196, 42, 0, // Skip to: 12450
/* 1502 */    MCD::OPC_Decode, 178, 3, 37, // Opcode: BTST8od
/* 1506 */    MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 1532
/* 1511 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1514 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1523
/* 1519 */    MCD::OPC_Decode, 170, 3, 37, // Opcode: BTST8ed
/* 1523 */    MCD::OPC_FilterValue, 1, 170, 42, 0, // Skip to: 12450
/* 1528 */    MCD::OPC_Decode, 180, 3, 38, // Opcode: BTST8pd
/* 1532 */    MCD::OPC_FilterValue, 19, 161, 42, 0, // Skip to: 12450
/* 1537 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1540 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1556
/* 1545 */    MCD::OPC_CheckField, 24, 4, 8, 146, 42, 0, // Skip to: 12450
/* 1552 */    MCD::OPC_Decode, 172, 3, 39, // Opcode: BTST8fd
/* 1556 */    MCD::OPC_FilterValue, 1, 137, 42, 0, // Skip to: 12450
/* 1561 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1564 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1573
/* 1569 */    MCD::OPC_Decode, 182, 3, 40, // Opcode: BTST8qd
/* 1573 */    MCD::OPC_FilterValue, 3, 120, 42, 0, // Skip to: 12450
/* 1578 */    MCD::OPC_CheckField, 24, 4, 8, 113, 42, 0, // Skip to: 12450
/* 1585 */    MCD::OPC_Decode, 176, 3, 41, // Opcode: BTST8kd
/* 1589 */    MCD::OPC_FilterValue, 1, 254, 4, 0, // Skip to: 2872
/* 1594 */    MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 1597 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1606
/* 1602 */    MCD::OPC_Decode, 202, 6, 42, // Opcode: MOV8dd
/* 1606 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1615
/* 1611 */    MCD::OPC_Decode, 206, 6, 43, // Opcode: MOV8dj
/* 1615 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 1624
/* 1620 */    MCD::OPC_Decode, 208, 6, 43, // Opcode: MOV8do
/* 1624 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 1633
/* 1629 */    MCD::OPC_Decode, 203, 6, 43, // Opcode: MOV8de
/* 1633 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 1642
/* 1638 */    MCD::OPC_Decode, 209, 6, 44, // Opcode: MOV8dp
/* 1642 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 1658
/* 1647 */    MCD::OPC_CheckField, 24, 4, 8, 44, 42, 0, // Skip to: 12450
/* 1654 */    MCD::OPC_Decode, 204, 6, 45, // Opcode: MOV8df
/* 1658 */    MCD::OPC_FilterValue, 7, 53, 0, 0, // Skip to: 1716
/* 1663 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1666 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1675
/* 1671 */    MCD::OPC_Decode, 201, 6, 46, // Opcode: MOV8db
/* 1675 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1684
/* 1680 */    MCD::OPC_Decode, 210, 6, 47, // Opcode: MOV8dq
/* 1684 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1700
/* 1689 */    MCD::OPC_CheckField, 24, 4, 8, 2, 42, 0, // Skip to: 12450
/* 1696 */    MCD::OPC_Decode, 207, 6, 48, // Opcode: MOV8dk
/* 1700 */    MCD::OPC_FilterValue, 4, 249, 41, 0, // Skip to: 12450
/* 1705 */    MCD::OPC_CheckField, 24, 8, 0, 242, 41, 0, // Skip to: 12450
/* 1712 */    MCD::OPC_Decode, 205, 6, 49, // Opcode: MOV8di
/* 1716 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1725
/* 1721 */    MCD::OPC_Decode, 232, 6, 50, // Opcode: MOV8jd
/* 1725 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1734
/* 1730 */    MCD::OPC_Decode, 236, 6, 51, // Opcode: MOV8jj
/* 1734 */    MCD::OPC_FilterValue, 19, 4, 0, 0, // Skip to: 1743
/* 1739 */    MCD::OPC_Decode, 238, 6, 51, // Opcode: MOV8jo
/* 1743 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 1752
/* 1748 */    MCD::OPC_Decode, 233, 6, 51, // Opcode: MOV8je
/* 1752 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 1761
/* 1757 */    MCD::OPC_Decode, 239, 6, 52, // Opcode: MOV8jp
/* 1761 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 1777
/* 1766 */    MCD::OPC_CheckField, 24, 4, 8, 181, 41, 0, // Skip to: 12450
/* 1773 */    MCD::OPC_Decode, 234, 6, 53, // Opcode: MOV8jf
/* 1777 */    MCD::OPC_FilterValue, 23, 53, 0, 0, // Skip to: 1835
/* 1782 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1785 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1794
/* 1790 */    MCD::OPC_Decode, 231, 6, 54, // Opcode: MOV8jb
/* 1794 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1803
/* 1799 */    MCD::OPC_Decode, 240, 6, 55, // Opcode: MOV8jq
/* 1803 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1819
/* 1808 */    MCD::OPC_CheckField, 24, 4, 8, 139, 41, 0, // Skip to: 12450
/* 1815 */    MCD::OPC_Decode, 237, 6, 56, // Opcode: MOV8jk
/* 1819 */    MCD::OPC_FilterValue, 4, 130, 41, 0, // Skip to: 12450
/* 1824 */    MCD::OPC_CheckField, 24, 8, 0, 123, 41, 0, // Skip to: 12450
/* 1831 */    MCD::OPC_Decode, 235, 6, 57, // Opcode: MOV8ji
/* 1835 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 1844
/* 1840 */    MCD::OPC_Decode, 252, 6, 50, // Opcode: MOV8od
/* 1844 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 1853
/* 1849 */    MCD::OPC_Decode, 128, 7, 51, // Opcode: MOV8oj
/* 1853 */    MCD::OPC_FilterValue, 27, 4, 0, 0, // Skip to: 1862
/* 1858 */    MCD::OPC_Decode, 130, 7, 51, // Opcode: MOV8oo
/* 1862 */    MCD::OPC_FilterValue, 28, 4, 0, 0, // Skip to: 1871
/* 1867 */    MCD::OPC_Decode, 253, 6, 51, // Opcode: MOV8oe
/* 1871 */    MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 1880
/* 1876 */    MCD::OPC_Decode, 131, 7, 52, // Opcode: MOV8op
/* 1880 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 1896
/* 1885 */    MCD::OPC_CheckField, 24, 4, 8, 62, 41, 0, // Skip to: 12450
/* 1892 */    MCD::OPC_Decode, 254, 6, 53, // Opcode: MOV8of
/* 1896 */    MCD::OPC_FilterValue, 31, 53, 0, 0, // Skip to: 1954
/* 1901 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1904 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1913
/* 1909 */    MCD::OPC_Decode, 251, 6, 54, // Opcode: MOV8ob
/* 1913 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1922
/* 1918 */    MCD::OPC_Decode, 132, 7, 55, // Opcode: MOV8oq
/* 1922 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1938
/* 1927 */    MCD::OPC_CheckField, 24, 4, 8, 20, 41, 0, // Skip to: 12450
/* 1934 */    MCD::OPC_Decode, 129, 7, 56, // Opcode: MOV8ok
/* 1938 */    MCD::OPC_FilterValue, 4, 11, 41, 0, // Skip to: 12450
/* 1943 */    MCD::OPC_CheckField, 24, 8, 0, 4, 41, 0, // Skip to: 12450
/* 1950 */    MCD::OPC_Decode, 255, 6, 57, // Opcode: MOV8oi
/* 1954 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 1963
/* 1959 */    MCD::OPC_Decode, 212, 6, 50, // Opcode: MOV8ed
/* 1963 */    MCD::OPC_FilterValue, 34, 4, 0, 0, // Skip to: 1972
/* 1968 */    MCD::OPC_Decode, 216, 6, 51, // Opcode: MOV8ej
/* 1972 */    MCD::OPC_FilterValue, 35, 4, 0, 0, // Skip to: 1981
/* 1977 */    MCD::OPC_Decode, 218, 6, 51, // Opcode: MOV8eo
/* 1981 */    MCD::OPC_FilterValue, 36, 4, 0, 0, // Skip to: 1990
/* 1986 */    MCD::OPC_Decode, 213, 6, 51, // Opcode: MOV8ee
/* 1990 */    MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 1999
/* 1995 */    MCD::OPC_Decode, 219, 6, 52, // Opcode: MOV8ep
/* 1999 */    MCD::OPC_FilterValue, 38, 11, 0, 0, // Skip to: 2015
/* 2004 */    MCD::OPC_CheckField, 24, 4, 8, 199, 40, 0, // Skip to: 12450
/* 2011 */    MCD::OPC_Decode, 214, 6, 53, // Opcode: MOV8ef
/* 2015 */    MCD::OPC_FilterValue, 39, 53, 0, 0, // Skip to: 2073
/* 2020 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2023 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2032
/* 2028 */    MCD::OPC_Decode, 211, 6, 54, // Opcode: MOV8eb
/* 2032 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2041
/* 2037 */    MCD::OPC_Decode, 220, 6, 55, // Opcode: MOV8eq
/* 2041 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2057
/* 2046 */    MCD::OPC_CheckField, 24, 4, 8, 157, 40, 0, // Skip to: 12450
/* 2053 */    MCD::OPC_Decode, 217, 6, 56, // Opcode: MOV8ek
/* 2057 */    MCD::OPC_FilterValue, 4, 148, 40, 0, // Skip to: 12450
/* 2062 */    MCD::OPC_CheckField, 24, 8, 0, 141, 40, 0, // Skip to: 12450
/* 2069 */    MCD::OPC_Decode, 215, 6, 57, // Opcode: MOV8ei
/* 2073 */    MCD::OPC_FilterValue, 40, 4, 0, 0, // Skip to: 2082
/* 2078 */    MCD::OPC_Decode, 134, 7, 58, // Opcode: MOV8pd
/* 2082 */    MCD::OPC_FilterValue, 42, 4, 0, 0, // Skip to: 2091
/* 2087 */    MCD::OPC_Decode, 138, 7, 59, // Opcode: MOV8pj
/* 2091 */    MCD::OPC_FilterValue, 43, 4, 0, 0, // Skip to: 2100
/* 2096 */    MCD::OPC_Decode, 140, 7, 59, // Opcode: MOV8po
/* 2100 */    MCD::OPC_FilterValue, 44, 4, 0, 0, // Skip to: 2109
/* 2105 */    MCD::OPC_Decode, 135, 7, 59, // Opcode: MOV8pe
/* 2109 */    MCD::OPC_FilterValue, 45, 4, 0, 0, // Skip to: 2118
/* 2114 */    MCD::OPC_Decode, 141, 7, 60, // Opcode: MOV8pp
/* 2118 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 2134
/* 2123 */    MCD::OPC_CheckField, 24, 4, 8, 80, 40, 0, // Skip to: 12450
/* 2130 */    MCD::OPC_Decode, 136, 7, 61, // Opcode: MOV8pf
/* 2134 */    MCD::OPC_FilterValue, 47, 53, 0, 0, // Skip to: 2192
/* 2139 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2142 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2151
/* 2147 */    MCD::OPC_Decode, 133, 7, 62, // Opcode: MOV8pb
/* 2151 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2160
/* 2156 */    MCD::OPC_Decode, 142, 7, 63, // Opcode: MOV8pq
/* 2160 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2176
/* 2165 */    MCD::OPC_CheckField, 24, 4, 8, 38, 40, 0, // Skip to: 12450
/* 2172 */    MCD::OPC_Decode, 139, 7, 64, // Opcode: MOV8pk
/* 2176 */    MCD::OPC_FilterValue, 4, 29, 40, 0, // Skip to: 12450
/* 2181 */    MCD::OPC_CheckField, 24, 8, 0, 22, 40, 0, // Skip to: 12450
/* 2188 */    MCD::OPC_Decode, 137, 7, 65, // Opcode: MOV8pi
/* 2192 */    MCD::OPC_FilterValue, 48, 11, 0, 0, // Skip to: 2208
/* 2197 */    MCD::OPC_CheckField, 24, 4, 8, 6, 40, 0, // Skip to: 12450
/* 2204 */    MCD::OPC_Decode, 222, 6, 66, // Opcode: MOV8fd
/* 2208 */    MCD::OPC_FilterValue, 50, 11, 0, 0, // Skip to: 2224
/* 2213 */    MCD::OPC_CheckField, 24, 4, 8, 246, 39, 0, // Skip to: 12450
/* 2220 */    MCD::OPC_Decode, 226, 6, 67, // Opcode: MOV8fj
/* 2224 */    MCD::OPC_FilterValue, 51, 11, 0, 0, // Skip to: 2240
/* 2229 */    MCD::OPC_CheckField, 24, 4, 8, 230, 39, 0, // Skip to: 12450
/* 2236 */    MCD::OPC_Decode, 228, 6, 67, // Opcode: MOV8fo
/* 2240 */    MCD::OPC_FilterValue, 52, 11, 0, 0, // Skip to: 2256
/* 2245 */    MCD::OPC_CheckField, 24, 4, 8, 214, 39, 0, // Skip to: 12450
/* 2252 */    MCD::OPC_Decode, 223, 6, 67, // Opcode: MOV8fe
/* 2256 */    MCD::OPC_FilterValue, 53, 11, 0, 0, // Skip to: 2272
/* 2261 */    MCD::OPC_CheckField, 40, 4, 8, 198, 39, 0, // Skip to: 12450
/* 2268 */    MCD::OPC_Decode, 229, 6, 68, // Opcode: MOV8fp
/* 2272 */    MCD::OPC_FilterValue, 54, 18, 0, 0, // Skip to: 2295
/* 2277 */    MCD::OPC_CheckField, 40, 4, 8, 182, 39, 0, // Skip to: 12450
/* 2284 */    MCD::OPC_CheckField, 24, 4, 8, 175, 39, 0, // Skip to: 12450
/* 2291 */    MCD::OPC_Decode, 224, 6, 69, // Opcode: MOV8ff
/* 2295 */    MCD::OPC_FilterValue, 55, 81, 0, 0, // Skip to: 2381
/* 2300 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2303 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2319
/* 2308 */    MCD::OPC_CheckField, 56, 4, 8, 151, 39, 0, // Skip to: 12450
/* 2315 */    MCD::OPC_Decode, 221, 6, 70, // Opcode: MOV8fb
/* 2319 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2335
/* 2324 */    MCD::OPC_CheckField, 40, 4, 8, 135, 39, 0, // Skip to: 12450
/* 2331 */    MCD::OPC_Decode, 230, 6, 71, // Opcode: MOV8fq
/* 2335 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 2358
/* 2340 */    MCD::OPC_CheckField, 40, 4, 8, 119, 39, 0, // Skip to: 12450
/* 2347 */    MCD::OPC_CheckField, 24, 4, 8, 112, 39, 0, // Skip to: 12450
/* 2354 */    MCD::OPC_Decode, 227, 6, 72, // Opcode: MOV8fk
/* 2358 */    MCD::OPC_FilterValue, 4, 103, 39, 0, // Skip to: 12450
/* 2363 */    MCD::OPC_CheckField, 40, 4, 8, 96, 39, 0, // Skip to: 12450
/* 2370 */    MCD::OPC_CheckField, 24, 8, 0, 89, 39, 0, // Skip to: 12450
/* 2377 */    MCD::OPC_Decode, 225, 6, 73, // Opcode: MOV8fi
/* 2381 */    MCD::OPC_FilterValue, 56, 37, 0, 0, // Skip to: 2423
/* 2386 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2389 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2398
/* 2394 */    MCD::OPC_Decode, 192, 6, 74, // Opcode: MOV8bd
/* 2398 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2407
/* 2403 */    MCD::OPC_Decode, 144, 7, 75, // Opcode: MOV8qd
/* 2407 */    MCD::OPC_FilterValue, 3, 54, 39, 0, // Skip to: 12450
/* 2412 */    MCD::OPC_CheckField, 24, 4, 8, 47, 39, 0, // Skip to: 12450
/* 2419 */    MCD::OPC_Decode, 242, 6, 76, // Opcode: MOV8kd
/* 2423 */    MCD::OPC_FilterValue, 58, 37, 0, 0, // Skip to: 2465
/* 2428 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2431 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2440
/* 2436 */    MCD::OPC_Decode, 196, 6, 77, // Opcode: MOV8bj
/* 2440 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2449
/* 2445 */    MCD::OPC_Decode, 148, 7, 17, // Opcode: MOV8qj
/* 2449 */    MCD::OPC_FilterValue, 3, 12, 39, 0, // Skip to: 12450
/* 2454 */    MCD::OPC_CheckField, 24, 4, 8, 5, 39, 0, // Skip to: 12450
/* 2461 */    MCD::OPC_Decode, 246, 6, 78, // Opcode: MOV8kj
/* 2465 */    MCD::OPC_FilterValue, 59, 37, 0, 0, // Skip to: 2507
/* 2470 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2473 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2482
/* 2478 */    MCD::OPC_Decode, 198, 6, 77, // Opcode: MOV8bo
/* 2482 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2491
/* 2487 */    MCD::OPC_Decode, 150, 7, 17, // Opcode: MOV8qo
/* 2491 */    MCD::OPC_FilterValue, 3, 226, 38, 0, // Skip to: 12450
/* 2496 */    MCD::OPC_CheckField, 24, 4, 8, 219, 38, 0, // Skip to: 12450
/* 2503 */    MCD::OPC_Decode, 248, 6, 78, // Opcode: MOV8ko
/* 2507 */    MCD::OPC_FilterValue, 60, 37, 0, 0, // Skip to: 2549
/* 2512 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2515 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2524
/* 2520 */    MCD::OPC_Decode, 193, 6, 77, // Opcode: MOV8be
/* 2524 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2533
/* 2529 */    MCD::OPC_Decode, 145, 7, 17, // Opcode: MOV8qe
/* 2533 */    MCD::OPC_FilterValue, 3, 184, 38, 0, // Skip to: 12450
/* 2538 */    MCD::OPC_CheckField, 24, 4, 8, 177, 38, 0, // Skip to: 12450
/* 2545 */    MCD::OPC_Decode, 243, 6, 78, // Opcode: MOV8ke
/* 2549 */    MCD::OPC_FilterValue, 61, 37, 0, 0, // Skip to: 2591
/* 2554 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2557 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2566
/* 2562 */    MCD::OPC_Decode, 199, 6, 79, // Opcode: MOV8bp
/* 2566 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2575
/* 2571 */    MCD::OPC_Decode, 151, 7, 80, // Opcode: MOV8qp
/* 2575 */    MCD::OPC_FilterValue, 3, 142, 38, 0, // Skip to: 12450
/* 2580 */    MCD::OPC_CheckField, 40, 4, 8, 135, 38, 0, // Skip to: 12450
/* 2587 */    MCD::OPC_Decode, 249, 6, 81, // Opcode: MOV8kp
/* 2591 */    MCD::OPC_FilterValue, 62, 58, 0, 0, // Skip to: 2654
/* 2596 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2599 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2615
/* 2604 */    MCD::OPC_CheckField, 24, 4, 8, 111, 38, 0, // Skip to: 12450
/* 2611 */    MCD::OPC_Decode, 194, 6, 82, // Opcode: MOV8bf
/* 2615 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2631
/* 2620 */    MCD::OPC_CheckField, 24, 4, 8, 95, 38, 0, // Skip to: 12450
/* 2627 */    MCD::OPC_Decode, 146, 7, 83, // Opcode: MOV8qf
/* 2631 */    MCD::OPC_FilterValue, 3, 86, 38, 0, // Skip to: 12450
/* 2636 */    MCD::OPC_CheckField, 40, 4, 8, 79, 38, 0, // Skip to: 12450
/* 2643 */    MCD::OPC_CheckField, 24, 4, 8, 72, 38, 0, // Skip to: 12450
/* 2650 */    MCD::OPC_Decode, 244, 6, 84, // Opcode: MOV8kf
/* 2654 */    MCD::OPC_FilterValue, 63, 63, 38, 0, // Skip to: 12450
/* 2659 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2662 */    MCD::OPC_FilterValue, 1, 37, 0, 0, // Skip to: 2704
/* 2667 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2670 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2679
/* 2675 */    MCD::OPC_Decode, 191, 6, 85, // Opcode: MOV8bb
/* 2679 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2688
/* 2684 */    MCD::OPC_Decode, 143, 7, 86, // Opcode: MOV8qb
/* 2688 */    MCD::OPC_FilterValue, 3, 29, 38, 0, // Skip to: 12450
/* 2693 */    MCD::OPC_CheckField, 56, 4, 8, 22, 38, 0, // Skip to: 12450
/* 2700 */    MCD::OPC_Decode, 241, 6, 87, // Opcode: MOV8kb
/* 2704 */    MCD::OPC_FilterValue, 2, 37, 0, 0, // Skip to: 2746
/* 2709 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2712 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2721
/* 2717 */    MCD::OPC_Decode, 200, 6, 88, // Opcode: MOV8bq
/* 2721 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2730
/* 2726 */    MCD::OPC_Decode, 152, 7, 89, // Opcode: MOV8qq
/* 2730 */    MCD::OPC_FilterValue, 3, 243, 37, 0, // Skip to: 12450
/* 2735 */    MCD::OPC_CheckField, 40, 4, 8, 236, 37, 0, // Skip to: 12450
/* 2742 */    MCD::OPC_Decode, 250, 6, 90, // Opcode: MOV8kq
/* 2746 */    MCD::OPC_FilterValue, 3, 58, 0, 0, // Skip to: 2809
/* 2751 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2754 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2770
/* 2759 */    MCD::OPC_CheckField, 24, 4, 8, 212, 37, 0, // Skip to: 12450
/* 2766 */    MCD::OPC_Decode, 197, 6, 91, // Opcode: MOV8bk
/* 2770 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2786
/* 2775 */    MCD::OPC_CheckField, 24, 4, 8, 196, 37, 0, // Skip to: 12450
/* 2782 */    MCD::OPC_Decode, 149, 7, 92, // Opcode: MOV8qk
/* 2786 */    MCD::OPC_FilterValue, 3, 187, 37, 0, // Skip to: 12450
/* 2791 */    MCD::OPC_CheckField, 40, 4, 8, 180, 37, 0, // Skip to: 12450
/* 2798 */    MCD::OPC_CheckField, 24, 4, 8, 173, 37, 0, // Skip to: 12450
/* 2805 */    MCD::OPC_Decode, 247, 6, 93, // Opcode: MOV8kk
/* 2809 */    MCD::OPC_FilterValue, 4, 164, 37, 0, // Skip to: 12450
/* 2814 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2817 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2833
/* 2822 */    MCD::OPC_CheckField, 24, 8, 0, 149, 37, 0, // Skip to: 12450
/* 2829 */    MCD::OPC_Decode, 195, 6, 94, // Opcode: MOV8bi
/* 2833 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2849
/* 2838 */    MCD::OPC_CheckField, 24, 8, 0, 133, 37, 0, // Skip to: 12450
/* 2845 */    MCD::OPC_Decode, 147, 7, 8, // Opcode: MOV8qi
/* 2849 */    MCD::OPC_FilterValue, 3, 124, 37, 0, // Skip to: 12450
/* 2854 */    MCD::OPC_CheckField, 40, 4, 8, 117, 37, 0, // Skip to: 12450
/* 2861 */    MCD::OPC_CheckField, 24, 8, 0, 110, 37, 0, // Skip to: 12450
/* 2868 */    MCD::OPC_Decode, 245, 6, 9, // Opcode: MOV8ki
/* 2872 */    MCD::OPC_FilterValue, 2, 179, 7, 0, // Skip to: 4848
/* 2877 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 2880 */    MCD::OPC_FilterValue, 0, 94, 1, 0, // Skip to: 3235
/* 2885 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 2888 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 2947
/* 2893 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2896 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2912
/* 2901 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 2932
/* 2908 */    MCD::OPC_Decode, 207, 5, 95, // Opcode: MOV32dd
/* 2912 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 2932
/* 2917 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 2928
/* 2924 */    MCD::OPC_Decode, 175, 5, 51, // Opcode: MOV32aa
/* 2928 */    MCD::OPC_Decode, 172, 6, 96, // Opcode: MOV32ra
/* 2932 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 2943
/* 2939 */    MCD::OPC_Decode, 193, 5, 97, // Opcode: MOV32ar
/* 2943 */    MCD::OPC_Decode, 190, 6, 98, // Opcode: MOV32rr
/* 2947 */    MCD::OPC_FilterValue, 1, 63, 0, 0, // Skip to: 3015
/* 2952 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 2955 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 2985
/* 2960 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2963 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2972
/* 2968 */    MCD::OPC_Decode, 242, 5, 99, // Opcode: MOV32jd
/* 2972 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2981
/* 2977 */    MCD::OPC_Decode, 240, 5, 51, // Opcode: MOV32ja
/* 2981 */    MCD::OPC_Decode, 251, 5, 97, // Opcode: MOV32jr
/* 2985 */    MCD::OPC_FilterValue, 1, 244, 36, 0, // Skip to: 12450
/* 2990 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2993 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3002
/* 2998 */    MCD::OPC_Decode, 138, 6, 99, // Opcode: MOV32od
/* 3002 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3011
/* 3007 */    MCD::OPC_Decode, 136, 6, 51, // Opcode: MOV32oa
/* 3011 */    MCD::OPC_Decode, 147, 6, 97, // Opcode: MOV32or
/* 3015 */    MCD::OPC_FilterValue, 2, 63, 0, 0, // Skip to: 3083
/* 3020 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3023 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3053
/* 3028 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3031 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3040
/* 3036 */    MCD::OPC_Decode, 218, 5, 99, // Opcode: MOV32ed
/* 3040 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3049
/* 3045 */    MCD::OPC_Decode, 216, 5, 51, // Opcode: MOV32ea
/* 3049 */    MCD::OPC_Decode, 227, 5, 97, // Opcode: MOV32er
/* 3053 */    MCD::OPC_FilterValue, 1, 176, 36, 0, // Skip to: 12450
/* 3058 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3061 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3070
/* 3066 */    MCD::OPC_Decode, 150, 6, 100, // Opcode: MOV32pd
/* 3070 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3079
/* 3075 */    MCD::OPC_Decode, 148, 6, 59, // Opcode: MOV32pa
/* 3079 */    MCD::OPC_Decode, 159, 6, 101, // Opcode: MOV32pr
/* 3083 */    MCD::OPC_FilterValue, 3, 146, 36, 0, // Skip to: 12450
/* 3088 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3091 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 3129
/* 3096 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3099 */    MCD::OPC_FilterValue, 8, 130, 36, 0, // Skip to: 12450
/* 3104 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3107 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3116
/* 3112 */    MCD::OPC_Decode, 230, 5, 102, // Opcode: MOV32fd
/* 3116 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3125
/* 3121 */    MCD::OPC_Decode, 228, 5, 67, // Opcode: MOV32fa
/* 3125 */    MCD::OPC_Decode, 239, 5, 103, // Opcode: MOV32fr
/* 3129 */    MCD::OPC_FilterValue, 1, 100, 36, 0, // Skip to: 12450
/* 3134 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3137 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 3167
/* 3142 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3145 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3154
/* 3150 */    MCD::OPC_Decode, 196, 5, 104, // Opcode: MOV32bd
/* 3154 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3163
/* 3159 */    MCD::OPC_Decode, 194, 5, 77, // Opcode: MOV32ba
/* 3163 */    MCD::OPC_Decode, 205, 5, 105, // Opcode: MOV32br
/* 3167 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 3197
/* 3172 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3175 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3184
/* 3180 */    MCD::OPC_Decode, 162, 6, 106, // Opcode: MOV32qd
/* 3184 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3193
/* 3189 */    MCD::OPC_Decode, 160, 6, 17, // Opcode: MOV32qa
/* 3193 */    MCD::OPC_Decode, 171, 6, 107, // Opcode: MOV32qr
/* 3197 */    MCD::OPC_FilterValue, 3, 32, 36, 0, // Skip to: 12450
/* 3202 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3205 */    MCD::OPC_FilterValue, 8, 24, 36, 0, // Skip to: 12450
/* 3210 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3213 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3222
/* 3218 */    MCD::OPC_Decode, 254, 5, 108, // Opcode: MOV32kd
/* 3222 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3231
/* 3227 */    MCD::OPC_Decode, 252, 5, 78, // Opcode: MOV32ka
/* 3231 */    MCD::OPC_Decode, 135, 6, 109, // Opcode: MOV32kr
/* 3235 */    MCD::OPC_FilterValue, 1, 75, 1, 0, // Skip to: 3571
/* 3240 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3243 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 3311
/* 3248 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3251 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3281
/* 3256 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3259 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3268
/* 3264 */    MCD::OPC_Decode, 211, 5, 110, // Opcode: MOV32dj
/* 3268 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3277
/* 3273 */    MCD::OPC_Decode, 183, 5, 51, // Opcode: MOV32aj
/* 3277 */    MCD::OPC_Decode, 180, 6, 96, // Opcode: MOV32rj
/* 3281 */    MCD::OPC_FilterValue, 1, 204, 35, 0, // Skip to: 12450
/* 3286 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3289 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3298
/* 3294 */    MCD::OPC_Decode, 213, 5, 110, // Opcode: MOV32do
/* 3298 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3307
/* 3303 */    MCD::OPC_Decode, 187, 5, 51, // Opcode: MOV32ao
/* 3307 */    MCD::OPC_Decode, 184, 6, 96, // Opcode: MOV32ro
/* 3311 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 3371
/* 3316 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3319 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3345
/* 3324 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3327 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3336
/* 3332 */    MCD::OPC_Decode, 246, 5, 51, // Opcode: MOV32jj
/* 3336 */    MCD::OPC_FilterValue, 1, 149, 35, 0, // Skip to: 12450
/* 3341 */    MCD::OPC_Decode, 142, 6, 51, // Opcode: MOV32oj
/* 3345 */    MCD::OPC_FilterValue, 1, 140, 35, 0, // Skip to: 12450
/* 3350 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3353 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3362
/* 3358 */    MCD::OPC_Decode, 248, 5, 51, // Opcode: MOV32jo
/* 3362 */    MCD::OPC_FilterValue, 1, 123, 35, 0, // Skip to: 12450
/* 3367 */    MCD::OPC_Decode, 144, 6, 51, // Opcode: MOV32oo
/* 3371 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 3431
/* 3376 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3379 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3405
/* 3384 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3387 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3396
/* 3392 */    MCD::OPC_Decode, 222, 5, 51, // Opcode: MOV32ej
/* 3396 */    MCD::OPC_FilterValue, 1, 89, 35, 0, // Skip to: 12450
/* 3401 */    MCD::OPC_Decode, 154, 6, 59, // Opcode: MOV32pj
/* 3405 */    MCD::OPC_FilterValue, 1, 80, 35, 0, // Skip to: 12450
/* 3410 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3413 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3422
/* 3418 */    MCD::OPC_Decode, 224, 5, 51, // Opcode: MOV32eo
/* 3422 */    MCD::OPC_FilterValue, 1, 63, 35, 0, // Skip to: 12450
/* 3427 */    MCD::OPC_Decode, 156, 6, 59, // Opcode: MOV32po
/* 3431 */    MCD::OPC_FilterValue, 3, 54, 35, 0, // Skip to: 12450
/* 3436 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3439 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 3505
/* 3444 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3447 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3463
/* 3452 */    MCD::OPC_CheckField, 24, 4, 8, 31, 35, 0, // Skip to: 12450
/* 3459 */    MCD::OPC_Decode, 234, 5, 67, // Opcode: MOV32fj
/* 3463 */    MCD::OPC_FilterValue, 1, 22, 35, 0, // Skip to: 12450
/* 3468 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3471 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3480
/* 3476 */    MCD::OPC_Decode, 200, 5, 77, // Opcode: MOV32bj
/* 3480 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3489
/* 3485 */    MCD::OPC_Decode, 166, 6, 17, // Opcode: MOV32qj
/* 3489 */    MCD::OPC_FilterValue, 3, 252, 34, 0, // Skip to: 12450
/* 3494 */    MCD::OPC_CheckField, 24, 4, 8, 245, 34, 0, // Skip to: 12450
/* 3501 */    MCD::OPC_Decode, 130, 6, 78, // Opcode: MOV32kj
/* 3505 */    MCD::OPC_FilterValue, 1, 236, 34, 0, // Skip to: 12450
/* 3510 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3513 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3529
/* 3518 */    MCD::OPC_CheckField, 24, 4, 8, 221, 34, 0, // Skip to: 12450
/* 3525 */    MCD::OPC_Decode, 236, 5, 67, // Opcode: MOV32fo
/* 3529 */    MCD::OPC_FilterValue, 1, 212, 34, 0, // Skip to: 12450
/* 3534 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3537 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3546
/* 3542 */    MCD::OPC_Decode, 202, 5, 77, // Opcode: MOV32bo
/* 3546 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3555
/* 3551 */    MCD::OPC_Decode, 168, 6, 17, // Opcode: MOV32qo
/* 3555 */    MCD::OPC_FilterValue, 3, 186, 34, 0, // Skip to: 12450
/* 3560 */    MCD::OPC_CheckField, 24, 4, 8, 179, 34, 0, // Skip to: 12450
/* 3567 */    MCD::OPC_Decode, 132, 6, 78, // Opcode: MOV32ko
/* 3571 */    MCD::OPC_FilterValue, 2, 75, 1, 0, // Skip to: 3907
/* 3576 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3579 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 3647
/* 3584 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3587 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3617
/* 3592 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3595 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3604
/* 3600 */    MCD::OPC_Decode, 208, 5, 110, // Opcode: MOV32de
/* 3604 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3613
/* 3609 */    MCD::OPC_Decode, 178, 5, 51, // Opcode: MOV32ae
/* 3613 */    MCD::OPC_Decode, 175, 6, 96, // Opcode: MOV32re
/* 3617 */    MCD::OPC_FilterValue, 1, 124, 34, 0, // Skip to: 12450
/* 3622 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3625 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3634
/* 3630 */    MCD::OPC_Decode, 214, 5, 111, // Opcode: MOV32dp
/* 3634 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3643
/* 3639 */    MCD::OPC_Decode, 189, 5, 52, // Opcode: MOV32ap
/* 3643 */    MCD::OPC_Decode, 186, 6, 112, // Opcode: MOV32rp
/* 3647 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 3707
/* 3652 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3655 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3681
/* 3660 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3663 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3672
/* 3668 */    MCD::OPC_Decode, 243, 5, 51, // Opcode: MOV32je
/* 3672 */    MCD::OPC_FilterValue, 1, 69, 34, 0, // Skip to: 12450
/* 3677 */    MCD::OPC_Decode, 139, 6, 51, // Opcode: MOV32oe
/* 3681 */    MCD::OPC_FilterValue, 1, 60, 34, 0, // Skip to: 12450
/* 3686 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3689 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3698
/* 3694 */    MCD::OPC_Decode, 249, 5, 52, // Opcode: MOV32jp
/* 3698 */    MCD::OPC_FilterValue, 1, 43, 34, 0, // Skip to: 12450
/* 3703 */    MCD::OPC_Decode, 145, 6, 52, // Opcode: MOV32op
/* 3707 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 3767
/* 3712 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3715 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3741
/* 3720 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3723 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3732
/* 3728 */    MCD::OPC_Decode, 219, 5, 51, // Opcode: MOV32ee
/* 3732 */    MCD::OPC_FilterValue, 1, 9, 34, 0, // Skip to: 12450
/* 3737 */    MCD::OPC_Decode, 151, 6, 59, // Opcode: MOV32pe
/* 3741 */    MCD::OPC_FilterValue, 1, 0, 34, 0, // Skip to: 12450
/* 3746 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3749 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3758
/* 3754 */    MCD::OPC_Decode, 225, 5, 52, // Opcode: MOV32ep
/* 3758 */    MCD::OPC_FilterValue, 1, 239, 33, 0, // Skip to: 12450
/* 3763 */    MCD::OPC_Decode, 157, 6, 60, // Opcode: MOV32pp
/* 3767 */    MCD::OPC_FilterValue, 3, 230, 33, 0, // Skip to: 12450
/* 3772 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3775 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 3841
/* 3780 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3783 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3799
/* 3788 */    MCD::OPC_CheckField, 24, 4, 8, 207, 33, 0, // Skip to: 12450
/* 3795 */    MCD::OPC_Decode, 231, 5, 67, // Opcode: MOV32fe
/* 3799 */    MCD::OPC_FilterValue, 1, 198, 33, 0, // Skip to: 12450
/* 3804 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3807 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3816
/* 3812 */    MCD::OPC_Decode, 197, 5, 77, // Opcode: MOV32be
/* 3816 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3825
/* 3821 */    MCD::OPC_Decode, 163, 6, 17, // Opcode: MOV32qe
/* 3825 */    MCD::OPC_FilterValue, 3, 172, 33, 0, // Skip to: 12450
/* 3830 */    MCD::OPC_CheckField, 24, 4, 8, 165, 33, 0, // Skip to: 12450
/* 3837 */    MCD::OPC_Decode, 255, 5, 78, // Opcode: MOV32ke
/* 3841 */    MCD::OPC_FilterValue, 1, 156, 33, 0, // Skip to: 12450
/* 3846 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3849 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3865
/* 3854 */    MCD::OPC_CheckField, 40, 4, 8, 141, 33, 0, // Skip to: 12450
/* 3861 */    MCD::OPC_Decode, 237, 5, 68, // Opcode: MOV32fp
/* 3865 */    MCD::OPC_FilterValue, 1, 132, 33, 0, // Skip to: 12450
/* 3870 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3873 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3882
/* 3878 */    MCD::OPC_Decode, 203, 5, 79, // Opcode: MOV32bp
/* 3882 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3891
/* 3887 */    MCD::OPC_Decode, 169, 6, 80, // Opcode: MOV32qp
/* 3891 */    MCD::OPC_FilterValue, 3, 106, 33, 0, // Skip to: 12450
/* 3896 */    MCD::OPC_CheckField, 40, 4, 8, 99, 33, 0, // Skip to: 12450
/* 3903 */    MCD::OPC_Decode, 133, 6, 81, // Opcode: MOV32kp
/* 3907 */    MCD::OPC_FilterValue, 3, 90, 33, 0, // Skip to: 12450
/* 3912 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3915 */    MCD::OPC_FilterValue, 0, 177, 0, 0, // Skip to: 4097
/* 3920 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3923 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 3961
/* 3928 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3931 */    MCD::OPC_FilterValue, 8, 66, 33, 0, // Skip to: 12450
/* 3936 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3939 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3948
/* 3944 */    MCD::OPC_Decode, 209, 5, 113, // Opcode: MOV32df
/* 3948 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3957
/* 3953 */    MCD::OPC_Decode, 180, 5, 53, // Opcode: MOV32af
/* 3957 */    MCD::OPC_Decode, 177, 6, 114, // Opcode: MOV32rf
/* 3961 */    MCD::OPC_FilterValue, 1, 36, 33, 0, // Skip to: 12450
/* 3966 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 3969 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 3999
/* 3974 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3977 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3986
/* 3982 */    MCD::OPC_Decode, 206, 5, 115, // Opcode: MOV32db
/* 3986 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3995
/* 3991 */    MCD::OPC_Decode, 176, 5, 54, // Opcode: MOV32ab
/* 3995 */    MCD::OPC_Decode, 173, 6, 116, // Opcode: MOV32rb
/* 3999 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 4029
/* 4004 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4007 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4016
/* 4012 */    MCD::OPC_Decode, 215, 5, 117, // Opcode: MOV32dq
/* 4016 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4025
/* 4021 */    MCD::OPC_Decode, 191, 5, 55, // Opcode: MOV32aq
/* 4025 */    MCD::OPC_Decode, 188, 6, 118, // Opcode: MOV32rq
/* 4029 */    MCD::OPC_FilterValue, 3, 33, 0, 0, // Skip to: 4067
/* 4034 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4037 */    MCD::OPC_FilterValue, 8, 216, 32, 0, // Skip to: 12450
/* 4042 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4045 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4054
/* 4050 */    MCD::OPC_Decode, 212, 5, 119, // Opcode: MOV32dk
/* 4054 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4063
/* 4059 */    MCD::OPC_Decode, 185, 5, 56, // Opcode: MOV32ak
/* 4063 */    MCD::OPC_Decode, 182, 6, 120, // Opcode: MOV32rk
/* 4067 */    MCD::OPC_FilterValue, 4, 186, 32, 0, // Skip to: 12450
/* 4072 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4075 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4084
/* 4080 */    MCD::OPC_Decode, 210, 5, 121, // Opcode: MOV32di
/* 4084 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4093
/* 4089 */    MCD::OPC_Decode, 182, 5, 122, // Opcode: MOV32ai
/* 4093 */    MCD::OPC_Decode, 179, 6, 123, // Opcode: MOV32ri
/* 4097 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 4271
/* 4102 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4105 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 4145
/* 4110 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4113 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4129
/* 4118 */    MCD::OPC_CheckField, 24, 4, 8, 133, 32, 0, // Skip to: 12450
/* 4125 */    MCD::OPC_Decode, 244, 5, 53, // Opcode: MOV32jf
/* 4129 */    MCD::OPC_FilterValue, 1, 124, 32, 0, // Skip to: 12450
/* 4134 */    MCD::OPC_CheckField, 24, 4, 8, 117, 32, 0, // Skip to: 12450
/* 4141 */    MCD::OPC_Decode, 140, 6, 53, // Opcode: MOV32of
/* 4145 */    MCD::OPC_FilterValue, 1, 108, 32, 0, // Skip to: 12450
/* 4150 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4153 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 4179
/* 4158 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4161 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4170
/* 4166 */    MCD::OPC_Decode, 241, 5, 54, // Opcode: MOV32jb
/* 4170 */    MCD::OPC_FilterValue, 1, 83, 32, 0, // Skip to: 12450
/* 4175 */    MCD::OPC_Decode, 137, 6, 54, // Opcode: MOV32ob
/* 4179 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 4205
/* 4184 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4187 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4196
/* 4192 */    MCD::OPC_Decode, 250, 5, 55, // Opcode: MOV32jq
/* 4196 */    MCD::OPC_FilterValue, 1, 57, 32, 0, // Skip to: 12450
/* 4201 */    MCD::OPC_Decode, 146, 6, 55, // Opcode: MOV32oq
/* 4205 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 4245
/* 4210 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4213 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4229
/* 4218 */    MCD::OPC_CheckField, 24, 4, 8, 33, 32, 0, // Skip to: 12450
/* 4225 */    MCD::OPC_Decode, 247, 5, 56, // Opcode: MOV32jk
/* 4229 */    MCD::OPC_FilterValue, 1, 24, 32, 0, // Skip to: 12450
/* 4234 */    MCD::OPC_CheckField, 24, 4, 8, 17, 32, 0, // Skip to: 12450
/* 4241 */    MCD::OPC_Decode, 143, 6, 56, // Opcode: MOV32ok
/* 4245 */    MCD::OPC_FilterValue, 4, 8, 32, 0, // Skip to: 12450
/* 4250 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4253 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4262
/* 4258 */    MCD::OPC_Decode, 245, 5, 122, // Opcode: MOV32ji
/* 4262 */    MCD::OPC_FilterValue, 1, 247, 31, 0, // Skip to: 12450
/* 4267 */    MCD::OPC_Decode, 141, 6, 122, // Opcode: MOV32oi
/* 4271 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 4445
/* 4276 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4279 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 4319
/* 4284 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4287 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4303
/* 4292 */    MCD::OPC_CheckField, 24, 4, 8, 215, 31, 0, // Skip to: 12450
/* 4299 */    MCD::OPC_Decode, 220, 5, 53, // Opcode: MOV32ef
/* 4303 */    MCD::OPC_FilterValue, 1, 206, 31, 0, // Skip to: 12450
/* 4308 */    MCD::OPC_CheckField, 24, 4, 8, 199, 31, 0, // Skip to: 12450
/* 4315 */    MCD::OPC_Decode, 152, 6, 61, // Opcode: MOV32pf
/* 4319 */    MCD::OPC_FilterValue, 1, 190, 31, 0, // Skip to: 12450
/* 4324 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4327 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 4353
/* 4332 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4335 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4344
/* 4340 */    MCD::OPC_Decode, 217, 5, 54, // Opcode: MOV32eb
/* 4344 */    MCD::OPC_FilterValue, 1, 165, 31, 0, // Skip to: 12450
/* 4349 */    MCD::OPC_Decode, 149, 6, 62, // Opcode: MOV32pb
/* 4353 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 4379
/* 4358 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4361 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4370
/* 4366 */    MCD::OPC_Decode, 226, 5, 55, // Opcode: MOV32eq
/* 4370 */    MCD::OPC_FilterValue, 1, 139, 31, 0, // Skip to: 12450
/* 4375 */    MCD::OPC_Decode, 158, 6, 63, // Opcode: MOV32pq
/* 4379 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 4419
/* 4384 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4387 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4403
/* 4392 */    MCD::OPC_CheckField, 24, 4, 8, 115, 31, 0, // Skip to: 12450
/* 4399 */    MCD::OPC_Decode, 223, 5, 56, // Opcode: MOV32ek
/* 4403 */    MCD::OPC_FilterValue, 1, 106, 31, 0, // Skip to: 12450
/* 4408 */    MCD::OPC_CheckField, 24, 4, 8, 99, 31, 0, // Skip to: 12450
/* 4415 */    MCD::OPC_Decode, 155, 6, 64, // Opcode: MOV32pk
/* 4419 */    MCD::OPC_FilterValue, 4, 90, 31, 0, // Skip to: 12450
/* 4424 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4427 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4436
/* 4432 */    MCD::OPC_Decode, 221, 5, 122, // Opcode: MOV32ei
/* 4436 */    MCD::OPC_FilterValue, 1, 73, 31, 0, // Skip to: 12450
/* 4441 */    MCD::OPC_Decode, 153, 6, 124, // Opcode: MOV32pi
/* 4445 */    MCD::OPC_FilterValue, 3, 64, 31, 0, // Skip to: 12450
/* 4450 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4453 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 4547
/* 4458 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4461 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 4484
/* 4466 */    MCD::OPC_CheckField, 40, 4, 8, 41, 31, 0, // Skip to: 12450
/* 4473 */    MCD::OPC_CheckField, 24, 4, 8, 34, 31, 0, // Skip to: 12450
/* 4480 */    MCD::OPC_Decode, 232, 5, 69, // Opcode: MOV32ff
/* 4484 */    MCD::OPC_FilterValue, 1, 25, 31, 0, // Skip to: 12450
/* 4489 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4492 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 4508
/* 4497 */    MCD::OPC_CheckField, 24, 4, 8, 10, 31, 0, // Skip to: 12450
/* 4504 */    MCD::OPC_Decode, 198, 5, 82, // Opcode: MOV32bf
/* 4508 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 4524
/* 4513 */    MCD::OPC_CheckField, 24, 4, 8, 250, 30, 0, // Skip to: 12450
/* 4520 */    MCD::OPC_Decode, 164, 6, 83, // Opcode: MOV32qf
/* 4524 */    MCD::OPC_FilterValue, 3, 241, 30, 0, // Skip to: 12450
/* 4529 */    MCD::OPC_CheckField, 40, 4, 8, 234, 30, 0, // Skip to: 12450
/* 4536 */    MCD::OPC_CheckField, 24, 4, 8, 227, 30, 0, // Skip to: 12450
/* 4543 */    MCD::OPC_Decode, 128, 6, 84, // Opcode: MOV32kf
/* 4547 */    MCD::OPC_FilterValue, 1, 218, 30, 0, // Skip to: 12450
/* 4552 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4555 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 4621
/* 4560 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4563 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4579
/* 4568 */    MCD::OPC_CheckField, 56, 4, 8, 195, 30, 0, // Skip to: 12450
/* 4575 */    MCD::OPC_Decode, 229, 5, 70, // Opcode: MOV32fb
/* 4579 */    MCD::OPC_FilterValue, 1, 186, 30, 0, // Skip to: 12450
/* 4584 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4587 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4596
/* 4592 */    MCD::OPC_Decode, 195, 5, 85, // Opcode: MOV32bb
/* 4596 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4605
/* 4601 */    MCD::OPC_Decode, 161, 6, 86, // Opcode: MOV32qb
/* 4605 */    MCD::OPC_FilterValue, 3, 160, 30, 0, // Skip to: 12450
/* 4610 */    MCD::OPC_CheckField, 56, 4, 8, 153, 30, 0, // Skip to: 12450
/* 4617 */    MCD::OPC_Decode, 253, 5, 87, // Opcode: MOV32kb
/* 4621 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 4687
/* 4626 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4629 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4645
/* 4634 */    MCD::OPC_CheckField, 40, 4, 8, 129, 30, 0, // Skip to: 12450
/* 4641 */    MCD::OPC_Decode, 238, 5, 71, // Opcode: MOV32fq
/* 4645 */    MCD::OPC_FilterValue, 1, 120, 30, 0, // Skip to: 12450
/* 4650 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4653 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4662
/* 4658 */    MCD::OPC_Decode, 204, 5, 88, // Opcode: MOV32bq
/* 4662 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4671
/* 4667 */    MCD::OPC_Decode, 170, 6, 89, // Opcode: MOV32qq
/* 4671 */    MCD::OPC_FilterValue, 3, 94, 30, 0, // Skip to: 12450
/* 4676 */    MCD::OPC_CheckField, 40, 4, 8, 87, 30, 0, // Skip to: 12450
/* 4683 */    MCD::OPC_Decode, 134, 6, 90, // Opcode: MOV32kq
/* 4687 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 4781
/* 4692 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4695 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 4718
/* 4700 */    MCD::OPC_CheckField, 40, 4, 8, 63, 30, 0, // Skip to: 12450
/* 4707 */    MCD::OPC_CheckField, 24, 4, 8, 56, 30, 0, // Skip to: 12450
/* 4714 */    MCD::OPC_Decode, 235, 5, 72, // Opcode: MOV32fk
/* 4718 */    MCD::OPC_FilterValue, 1, 47, 30, 0, // Skip to: 12450
/* 4723 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4726 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 4742
/* 4731 */    MCD::OPC_CheckField, 24, 4, 8, 32, 30, 0, // Skip to: 12450
/* 4738 */    MCD::OPC_Decode, 201, 5, 91, // Opcode: MOV32bk
/* 4742 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 4758
/* 4747 */    MCD::OPC_CheckField, 24, 4, 8, 16, 30, 0, // Skip to: 12450
/* 4754 */    MCD::OPC_Decode, 167, 6, 92, // Opcode: MOV32qk
/* 4758 */    MCD::OPC_FilterValue, 3, 7, 30, 0, // Skip to: 12450
/* 4763 */    MCD::OPC_CheckField, 40, 4, 8, 0, 30, 0, // Skip to: 12450
/* 4770 */    MCD::OPC_CheckField, 24, 4, 8, 249, 29, 0, // Skip to: 12450
/* 4777 */    MCD::OPC_Decode, 131, 6, 93, // Opcode: MOV32kk
/* 4781 */    MCD::OPC_FilterValue, 4, 240, 29, 0, // Skip to: 12450
/* 4786 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4789 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4805
/* 4794 */    MCD::OPC_CheckField, 56, 4, 8, 225, 29, 0, // Skip to: 12450
/* 4801 */    MCD::OPC_Decode, 233, 5, 125, // Opcode: MOV32fi
/* 4805 */    MCD::OPC_FilterValue, 1, 216, 29, 0, // Skip to: 12450
/* 4810 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4813 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4822
/* 4818 */    MCD::OPC_Decode, 199, 5, 126, // Opcode: MOV32bi
/* 4822 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4831
/* 4827 */    MCD::OPC_Decode, 165, 6, 127, // Opcode: MOV32qi
/* 4831 */    MCD::OPC_FilterValue, 3, 190, 29, 0, // Skip to: 12450
/* 4836 */    MCD::OPC_CheckField, 56, 4, 8, 183, 29, 0, // Skip to: 12450
/* 4843 */    MCD::OPC_Decode, 129, 6, 128, 1, // Opcode: MOV32ki
/* 4848 */    MCD::OPC_FilterValue, 3, 233, 7, 0, // Skip to: 6878
/* 4853 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 4856 */    MCD::OPC_FilterValue, 0, 122, 1, 0, // Skip to: 5239
/* 4861 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4864 */    MCD::OPC_FilterValue, 0, 59, 0, 0, // Skip to: 4928
/* 4869 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4872 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 4889
/* 4877 */    MCD::OPC_CheckField, 6, 1, 0, 27, 0, 0, // Skip to: 4911
/* 4884 */    MCD::OPC_Decode, 184, 4, 129, 1, // Opcode: MOV16dd
/* 4889 */    MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 4911
/* 4894 */    MCD::OPC_CheckField, 6, 1, 1, 5, 0, 0, // Skip to: 4906
/* 4901 */    MCD::OPC_Decode, 141, 4, 130, 1, // Opcode: MOV16aa
/* 4906 */    MCD::OPC_Decode, 156, 5, 131, 1, // Opcode: MOV16ra
/* 4911 */    MCD::OPC_CheckField, 6, 1, 1, 5, 0, 0, // Skip to: 4923
/* 4918 */    MCD::OPC_Decode, 159, 4, 132, 1, // Opcode: MOV16ar
/* 4923 */    MCD::OPC_Decode, 174, 5, 133, 1, // Opcode: MOV16rr
/* 4928 */    MCD::OPC_FilterValue, 1, 69, 0, 0, // Skip to: 5002
/* 4933 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4936 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 4969
/* 4941 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4944 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 4954
/* 4949 */    MCD::OPC_Decode, 222, 4, 134, 1, // Opcode: MOV16jd
/* 4954 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 4964
/* 4959 */    MCD::OPC_Decode, 219, 4, 135, 1, // Opcode: MOV16ja
/* 4964 */    MCD::OPC_Decode, 231, 4, 136, 1, // Opcode: MOV16jr
/* 4969 */    MCD::OPC_FilterValue, 1, 52, 29, 0, // Skip to: 12450
/* 4974 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4977 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 4987
/* 4982 */    MCD::OPC_Decode, 248, 4, 134, 1, // Opcode: MOV16od
/* 4987 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 4997
/* 4992 */    MCD::OPC_Decode, 245, 4, 135, 1, // Opcode: MOV16oa
/* 4997 */    MCD::OPC_Decode, 129, 5, 136, 1, // Opcode: MOV16or
/* 5002 */    MCD::OPC_FilterValue, 2, 69, 0, 0, // Skip to: 5076
/* 5007 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5010 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 5043
/* 5015 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5018 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5028
/* 5023 */    MCD::OPC_Decode, 196, 4, 134, 1, // Opcode: MOV16ed
/* 5028 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5038
/* 5033 */    MCD::OPC_Decode, 193, 4, 135, 1, // Opcode: MOV16ea
/* 5038 */    MCD::OPC_Decode, 205, 4, 136, 1, // Opcode: MOV16er
/* 5043 */    MCD::OPC_FilterValue, 1, 234, 28, 0, // Skip to: 12450
/* 5048 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5051 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5061
/* 5056 */    MCD::OPC_Decode, 133, 5, 137, 1, // Opcode: MOV16pd
/* 5061 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5071
/* 5066 */    MCD::OPC_Decode, 130, 5, 138, 1, // Opcode: MOV16pa
/* 5071 */    MCD::OPC_Decode, 142, 5, 139, 1, // Opcode: MOV16pr
/* 5076 */    MCD::OPC_FilterValue, 3, 201, 28, 0, // Skip to: 12450
/* 5081 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5084 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 5125
/* 5089 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5092 */    MCD::OPC_FilterValue, 8, 185, 28, 0, // Skip to: 12450
/* 5097 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5100 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5110
/* 5105 */    MCD::OPC_Decode, 209, 4, 140, 1, // Opcode: MOV16fd
/* 5110 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5120
/* 5115 */    MCD::OPC_Decode, 206, 4, 141, 1, // Opcode: MOV16fa
/* 5120 */    MCD::OPC_Decode, 218, 4, 142, 1, // Opcode: MOV16fr
/* 5125 */    MCD::OPC_FilterValue, 1, 152, 28, 0, // Skip to: 12450
/* 5130 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5133 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 5166
/* 5138 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5141 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5151
/* 5146 */    MCD::OPC_Decode, 163, 4, 143, 1, // Opcode: MOV16bd
/* 5151 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5161
/* 5156 */    MCD::OPC_Decode, 160, 4, 144, 1, // Opcode: MOV16ba
/* 5161 */    MCD::OPC_Decode, 172, 4, 145, 1, // Opcode: MOV16br
/* 5166 */    MCD::OPC_FilterValue, 2, 27, 0, 0, // Skip to: 5198
/* 5171 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5174 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5183
/* 5179 */    MCD::OPC_Decode, 146, 5, 15, // Opcode: MOV16qd
/* 5183 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5193
/* 5188 */    MCD::OPC_Decode, 143, 5, 146, 1, // Opcode: MOV16qa
/* 5193 */    MCD::OPC_Decode, 155, 5, 147, 1, // Opcode: MOV16qr
/* 5198 */    MCD::OPC_FilterValue, 3, 79, 28, 0, // Skip to: 12450
/* 5203 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5206 */    MCD::OPC_FilterValue, 8, 71, 28, 0, // Skip to: 12450
/* 5211 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5214 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5224
/* 5219 */    MCD::OPC_Decode, 235, 4, 148, 1, // Opcode: MOV16kd
/* 5224 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5234
/* 5229 */    MCD::OPC_Decode, 232, 4, 149, 1, // Opcode: MOV16ka
/* 5234 */    MCD::OPC_Decode, 244, 4, 150, 1, // Opcode: MOV16kr
/* 5239 */    MCD::OPC_FilterValue, 1, 81, 1, 0, // Skip to: 5581
/* 5244 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5247 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 5321
/* 5252 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5255 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 5288
/* 5260 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5263 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5273
/* 5268 */    MCD::OPC_Decode, 188, 4, 151, 1, // Opcode: MOV16dj
/* 5273 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5283
/* 5278 */    MCD::OPC_Decode, 149, 4, 152, 1, // Opcode: MOV16aj
/* 5283 */    MCD::OPC_Decode, 164, 5, 153, 1, // Opcode: MOV16rj
/* 5288 */    MCD::OPC_FilterValue, 1, 245, 27, 0, // Skip to: 12450
/* 5293 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5296 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5306
/* 5301 */    MCD::OPC_Decode, 190, 4, 151, 1, // Opcode: MOV16do
/* 5306 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5316
/* 5311 */    MCD::OPC_Decode, 153, 4, 152, 1, // Opcode: MOV16ao
/* 5316 */    MCD::OPC_Decode, 168, 5, 153, 1, // Opcode: MOV16ro
/* 5321 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 5381
/* 5326 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5329 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5355
/* 5334 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5337 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5346
/* 5342 */    MCD::OPC_Decode, 226, 4, 51, // Opcode: MOV16jj
/* 5346 */    MCD::OPC_FilterValue, 1, 187, 27, 0, // Skip to: 12450
/* 5351 */    MCD::OPC_Decode, 252, 4, 51, // Opcode: MOV16oj
/* 5355 */    MCD::OPC_FilterValue, 1, 178, 27, 0, // Skip to: 12450
/* 5360 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5363 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5372
/* 5368 */    MCD::OPC_Decode, 228, 4, 51, // Opcode: MOV16jo
/* 5372 */    MCD::OPC_FilterValue, 1, 161, 27, 0, // Skip to: 12450
/* 5377 */    MCD::OPC_Decode, 254, 4, 51, // Opcode: MOV16oo
/* 5381 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 5441
/* 5386 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5389 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5415
/* 5394 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5397 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5406
/* 5402 */    MCD::OPC_Decode, 200, 4, 51, // Opcode: MOV16ej
/* 5406 */    MCD::OPC_FilterValue, 1, 127, 27, 0, // Skip to: 12450
/* 5411 */    MCD::OPC_Decode, 137, 5, 59, // Opcode: MOV16pj
/* 5415 */    MCD::OPC_FilterValue, 1, 118, 27, 0, // Skip to: 12450
/* 5420 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5423 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5432
/* 5428 */    MCD::OPC_Decode, 202, 4, 51, // Opcode: MOV16eo
/* 5432 */    MCD::OPC_FilterValue, 1, 101, 27, 0, // Skip to: 12450
/* 5437 */    MCD::OPC_Decode, 139, 5, 59, // Opcode: MOV16po
/* 5441 */    MCD::OPC_FilterValue, 3, 92, 27, 0, // Skip to: 12450
/* 5446 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5449 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 5515
/* 5454 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5457 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5473
/* 5462 */    MCD::OPC_CheckField, 24, 4, 8, 69, 27, 0, // Skip to: 12450
/* 5469 */    MCD::OPC_Decode, 213, 4, 67, // Opcode: MOV16fj
/* 5473 */    MCD::OPC_FilterValue, 1, 60, 27, 0, // Skip to: 12450
/* 5478 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5481 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5490
/* 5486 */    MCD::OPC_Decode, 167, 4, 77, // Opcode: MOV16bj
/* 5490 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5499
/* 5495 */    MCD::OPC_Decode, 150, 5, 17, // Opcode: MOV16qj
/* 5499 */    MCD::OPC_FilterValue, 3, 34, 27, 0, // Skip to: 12450
/* 5504 */    MCD::OPC_CheckField, 24, 4, 8, 27, 27, 0, // Skip to: 12450
/* 5511 */    MCD::OPC_Decode, 239, 4, 78, // Opcode: MOV16kj
/* 5515 */    MCD::OPC_FilterValue, 1, 18, 27, 0, // Skip to: 12450
/* 5520 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5523 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5539
/* 5528 */    MCD::OPC_CheckField, 24, 4, 8, 3, 27, 0, // Skip to: 12450
/* 5535 */    MCD::OPC_Decode, 215, 4, 67, // Opcode: MOV16fo
/* 5539 */    MCD::OPC_FilterValue, 1, 250, 26, 0, // Skip to: 12450
/* 5544 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5547 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5556
/* 5552 */    MCD::OPC_Decode, 169, 4, 77, // Opcode: MOV16bo
/* 5556 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5565
/* 5561 */    MCD::OPC_Decode, 152, 5, 17, // Opcode: MOV16qo
/* 5565 */    MCD::OPC_FilterValue, 3, 224, 26, 0, // Skip to: 12450
/* 5570 */    MCD::OPC_CheckField, 24, 4, 8, 217, 26, 0, // Skip to: 12450
/* 5577 */    MCD::OPC_Decode, 241, 4, 78, // Opcode: MOV16ko
/* 5581 */    MCD::OPC_FilterValue, 2, 81, 1, 0, // Skip to: 5923
/* 5586 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5589 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 5663
/* 5594 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5597 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 5630
/* 5602 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5605 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5615
/* 5610 */    MCD::OPC_Decode, 185, 4, 151, 1, // Opcode: MOV16de
/* 5615 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5625
/* 5620 */    MCD::OPC_Decode, 144, 4, 152, 1, // Opcode: MOV16ae
/* 5625 */    MCD::OPC_Decode, 159, 5, 153, 1, // Opcode: MOV16re
/* 5630 */    MCD::OPC_FilterValue, 1, 159, 26, 0, // Skip to: 12450
/* 5635 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5638 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5648
/* 5643 */    MCD::OPC_Decode, 191, 4, 154, 1, // Opcode: MOV16dp
/* 5648 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5658
/* 5653 */    MCD::OPC_Decode, 155, 4, 155, 1, // Opcode: MOV16ap
/* 5658 */    MCD::OPC_Decode, 170, 5, 156, 1, // Opcode: MOV16rp
/* 5663 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 5723
/* 5668 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5671 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5697
/* 5676 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5679 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5688
/* 5684 */    MCD::OPC_Decode, 223, 4, 51, // Opcode: MOV16je
/* 5688 */    MCD::OPC_FilterValue, 1, 101, 26, 0, // Skip to: 12450
/* 5693 */    MCD::OPC_Decode, 249, 4, 51, // Opcode: MOV16oe
/* 5697 */    MCD::OPC_FilterValue, 1, 92, 26, 0, // Skip to: 12450
/* 5702 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5705 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5714
/* 5710 */    MCD::OPC_Decode, 229, 4, 52, // Opcode: MOV16jp
/* 5714 */    MCD::OPC_FilterValue, 1, 75, 26, 0, // Skip to: 12450
/* 5719 */    MCD::OPC_Decode, 255, 4, 52, // Opcode: MOV16op
/* 5723 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 5783
/* 5728 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5731 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5757
/* 5736 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5739 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5748
/* 5744 */    MCD::OPC_Decode, 197, 4, 51, // Opcode: MOV16ee
/* 5748 */    MCD::OPC_FilterValue, 1, 41, 26, 0, // Skip to: 12450
/* 5753 */    MCD::OPC_Decode, 134, 5, 59, // Opcode: MOV16pe
/* 5757 */    MCD::OPC_FilterValue, 1, 32, 26, 0, // Skip to: 12450
/* 5762 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5765 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5774
/* 5770 */    MCD::OPC_Decode, 203, 4, 52, // Opcode: MOV16ep
/* 5774 */    MCD::OPC_FilterValue, 1, 15, 26, 0, // Skip to: 12450
/* 5779 */    MCD::OPC_Decode, 140, 5, 60, // Opcode: MOV16pp
/* 5783 */    MCD::OPC_FilterValue, 3, 6, 26, 0, // Skip to: 12450
/* 5788 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5791 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 5857
/* 5796 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5799 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5815
/* 5804 */    MCD::OPC_CheckField, 24, 4, 8, 239, 25, 0, // Skip to: 12450
/* 5811 */    MCD::OPC_Decode, 210, 4, 67, // Opcode: MOV16fe
/* 5815 */    MCD::OPC_FilterValue, 1, 230, 25, 0, // Skip to: 12450
/* 5820 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5823 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5832
/* 5828 */    MCD::OPC_Decode, 164, 4, 77, // Opcode: MOV16be
/* 5832 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5841
/* 5837 */    MCD::OPC_Decode, 147, 5, 17, // Opcode: MOV16qe
/* 5841 */    MCD::OPC_FilterValue, 3, 204, 25, 0, // Skip to: 12450
/* 5846 */    MCD::OPC_CheckField, 24, 4, 8, 197, 25, 0, // Skip to: 12450
/* 5853 */    MCD::OPC_Decode, 236, 4, 78, // Opcode: MOV16ke
/* 5857 */    MCD::OPC_FilterValue, 1, 188, 25, 0, // Skip to: 12450
/* 5862 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5865 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5881
/* 5870 */    MCD::OPC_CheckField, 40, 4, 8, 173, 25, 0, // Skip to: 12450
/* 5877 */    MCD::OPC_Decode, 216, 4, 68, // Opcode: MOV16fp
/* 5881 */    MCD::OPC_FilterValue, 1, 164, 25, 0, // Skip to: 12450
/* 5886 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5889 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5898
/* 5894 */    MCD::OPC_Decode, 170, 4, 79, // Opcode: MOV16bp
/* 5898 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5907
/* 5903 */    MCD::OPC_Decode, 153, 5, 80, // Opcode: MOV16qp
/* 5907 */    MCD::OPC_FilterValue, 3, 138, 25, 0, // Skip to: 12450
/* 5912 */    MCD::OPC_CheckField, 40, 4, 8, 131, 25, 0, // Skip to: 12450
/* 5919 */    MCD::OPC_Decode, 242, 4, 81, // Opcode: MOV16kp
/* 5923 */    MCD::OPC_FilterValue, 3, 122, 25, 0, // Skip to: 12450
/* 5928 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5931 */    MCD::OPC_FilterValue, 0, 192, 0, 0, // Skip to: 6128
/* 5936 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5939 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 5980
/* 5944 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5947 */    MCD::OPC_FilterValue, 8, 98, 25, 0, // Skip to: 12450
/* 5952 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5955 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5965
/* 5960 */    MCD::OPC_Decode, 186, 4, 157, 1, // Opcode: MOV16df
/* 5965 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5975
/* 5970 */    MCD::OPC_Decode, 146, 4, 158, 1, // Opcode: MOV16af
/* 5975 */    MCD::OPC_Decode, 161, 5, 159, 1, // Opcode: MOV16rf
/* 5980 */    MCD::OPC_FilterValue, 1, 65, 25, 0, // Skip to: 12450
/* 5985 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 5988 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 6021
/* 5993 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5996 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6006
/* 6001 */    MCD::OPC_Decode, 182, 4, 160, 1, // Opcode: MOV16db
/* 6006 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6016
/* 6011 */    MCD::OPC_Decode, 142, 4, 161, 1, // Opcode: MOV16ab
/* 6016 */    MCD::OPC_Decode, 157, 5, 162, 1, // Opcode: MOV16rb
/* 6021 */    MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 6054
/* 6026 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6029 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6039
/* 6034 */    MCD::OPC_Decode, 192, 4, 163, 1, // Opcode: MOV16dq
/* 6039 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6049
/* 6044 */    MCD::OPC_Decode, 157, 4, 164, 1, // Opcode: MOV16aq
/* 6049 */    MCD::OPC_Decode, 172, 5, 165, 1, // Opcode: MOV16rq
/* 6054 */    MCD::OPC_FilterValue, 3, 36, 0, 0, // Skip to: 6095
/* 6059 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6062 */    MCD::OPC_FilterValue, 8, 239, 24, 0, // Skip to: 12450
/* 6067 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6070 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6080
/* 6075 */    MCD::OPC_Decode, 189, 4, 166, 1, // Opcode: MOV16dk
/* 6080 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6090
/* 6085 */    MCD::OPC_Decode, 151, 4, 167, 1, // Opcode: MOV16ak
/* 6090 */    MCD::OPC_Decode, 166, 5, 168, 1, // Opcode: MOV16rk
/* 6095 */    MCD::OPC_FilterValue, 4, 206, 24, 0, // Skip to: 12450
/* 6100 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6103 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6113
/* 6108 */    MCD::OPC_Decode, 187, 4, 163, 1, // Opcode: MOV16di
/* 6113 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6123
/* 6118 */    MCD::OPC_Decode, 148, 4, 164, 1, // Opcode: MOV16ai
/* 6123 */    MCD::OPC_Decode, 163, 5, 165, 1, // Opcode: MOV16ri
/* 6128 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 6302
/* 6133 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6136 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 6176
/* 6141 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6144 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6160
/* 6149 */    MCD::OPC_CheckField, 24, 4, 8, 150, 24, 0, // Skip to: 12450
/* 6156 */    MCD::OPC_Decode, 224, 4, 53, // Opcode: MOV16jf
/* 6160 */    MCD::OPC_FilterValue, 1, 141, 24, 0, // Skip to: 12450
/* 6165 */    MCD::OPC_CheckField, 24, 4, 8, 134, 24, 0, // Skip to: 12450
/* 6172 */    MCD::OPC_Decode, 250, 4, 53, // Opcode: MOV16of
/* 6176 */    MCD::OPC_FilterValue, 1, 125, 24, 0, // Skip to: 12450
/* 6181 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6184 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 6210
/* 6189 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6192 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6201
/* 6197 */    MCD::OPC_Decode, 220, 4, 54, // Opcode: MOV16jb
/* 6201 */    MCD::OPC_FilterValue, 1, 100, 24, 0, // Skip to: 12450
/* 6206 */    MCD::OPC_Decode, 246, 4, 54, // Opcode: MOV16ob
/* 6210 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 6236
/* 6215 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6218 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6227
/* 6223 */    MCD::OPC_Decode, 230, 4, 55, // Opcode: MOV16jq
/* 6227 */    MCD::OPC_FilterValue, 1, 74, 24, 0, // Skip to: 12450
/* 6232 */    MCD::OPC_Decode, 128, 5, 55, // Opcode: MOV16oq
/* 6236 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 6276
/* 6241 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6244 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6260
/* 6249 */    MCD::OPC_CheckField, 24, 4, 8, 50, 24, 0, // Skip to: 12450
/* 6256 */    MCD::OPC_Decode, 227, 4, 56, // Opcode: MOV16jk
/* 6260 */    MCD::OPC_FilterValue, 1, 41, 24, 0, // Skip to: 12450
/* 6265 */    MCD::OPC_CheckField, 24, 4, 8, 34, 24, 0, // Skip to: 12450
/* 6272 */    MCD::OPC_Decode, 253, 4, 56, // Opcode: MOV16ok
/* 6276 */    MCD::OPC_FilterValue, 4, 25, 24, 0, // Skip to: 12450
/* 6281 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6284 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6293
/* 6289 */    MCD::OPC_Decode, 225, 4, 55, // Opcode: MOV16ji
/* 6293 */    MCD::OPC_FilterValue, 1, 8, 24, 0, // Skip to: 12450
/* 6298 */    MCD::OPC_Decode, 251, 4, 55, // Opcode: MOV16oi
/* 6302 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 6476
/* 6307 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6310 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 6350
/* 6315 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6318 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6334
/* 6323 */    MCD::OPC_CheckField, 24, 4, 8, 232, 23, 0, // Skip to: 12450
/* 6330 */    MCD::OPC_Decode, 198, 4, 53, // Opcode: MOV16ef
/* 6334 */    MCD::OPC_FilterValue, 1, 223, 23, 0, // Skip to: 12450
/* 6339 */    MCD::OPC_CheckField, 24, 4, 8, 216, 23, 0, // Skip to: 12450
/* 6346 */    MCD::OPC_Decode, 135, 5, 61, // Opcode: MOV16pf
/* 6350 */    MCD::OPC_FilterValue, 1, 207, 23, 0, // Skip to: 12450
/* 6355 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6358 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 6384
/* 6363 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6366 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6375
/* 6371 */    MCD::OPC_Decode, 194, 4, 54, // Opcode: MOV16eb
/* 6375 */    MCD::OPC_FilterValue, 1, 182, 23, 0, // Skip to: 12450
/* 6380 */    MCD::OPC_Decode, 131, 5, 62, // Opcode: MOV16pb
/* 6384 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 6410
/* 6389 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6392 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6401
/* 6397 */    MCD::OPC_Decode, 204, 4, 55, // Opcode: MOV16eq
/* 6401 */    MCD::OPC_FilterValue, 1, 156, 23, 0, // Skip to: 12450
/* 6406 */    MCD::OPC_Decode, 141, 5, 63, // Opcode: MOV16pq
/* 6410 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 6450
/* 6415 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6418 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6434
/* 6423 */    MCD::OPC_CheckField, 24, 4, 8, 132, 23, 0, // Skip to: 12450
/* 6430 */    MCD::OPC_Decode, 201, 4, 56, // Opcode: MOV16ek
/* 6434 */    MCD::OPC_FilterValue, 1, 123, 23, 0, // Skip to: 12450
/* 6439 */    MCD::OPC_CheckField, 24, 4, 8, 116, 23, 0, // Skip to: 12450
/* 6446 */    MCD::OPC_Decode, 138, 5, 64, // Opcode: MOV16pk
/* 6450 */    MCD::OPC_FilterValue, 4, 107, 23, 0, // Skip to: 12450
/* 6455 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6458 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6467
/* 6463 */    MCD::OPC_Decode, 199, 4, 55, // Opcode: MOV16ei
/* 6467 */    MCD::OPC_FilterValue, 1, 90, 23, 0, // Skip to: 12450
/* 6472 */    MCD::OPC_Decode, 136, 5, 63, // Opcode: MOV16pi
/* 6476 */    MCD::OPC_FilterValue, 3, 81, 23, 0, // Skip to: 12450
/* 6481 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6484 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 6578
/* 6489 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6492 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 6515
/* 6497 */    MCD::OPC_CheckField, 40, 4, 8, 58, 23, 0, // Skip to: 12450
/* 6504 */    MCD::OPC_CheckField, 24, 4, 8, 51, 23, 0, // Skip to: 12450
/* 6511 */    MCD::OPC_Decode, 211, 4, 69, // Opcode: MOV16ff
/* 6515 */    MCD::OPC_FilterValue, 1, 42, 23, 0, // Skip to: 12450
/* 6520 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6523 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 6539
/* 6528 */    MCD::OPC_CheckField, 24, 4, 8, 27, 23, 0, // Skip to: 12450
/* 6535 */    MCD::OPC_Decode, 165, 4, 82, // Opcode: MOV16bf
/* 6539 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 6555
/* 6544 */    MCD::OPC_CheckField, 24, 4, 8, 11, 23, 0, // Skip to: 12450
/* 6551 */    MCD::OPC_Decode, 148, 5, 83, // Opcode: MOV16qf
/* 6555 */    MCD::OPC_FilterValue, 3, 2, 23, 0, // Skip to: 12450
/* 6560 */    MCD::OPC_CheckField, 40, 4, 8, 251, 22, 0, // Skip to: 12450
/* 6567 */    MCD::OPC_CheckField, 24, 4, 8, 244, 22, 0, // Skip to: 12450
/* 6574 */    MCD::OPC_Decode, 237, 4, 84, // Opcode: MOV16kf
/* 6578 */    MCD::OPC_FilterValue, 1, 235, 22, 0, // Skip to: 12450
/* 6583 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6586 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 6652
/* 6591 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6594 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6610
/* 6599 */    MCD::OPC_CheckField, 56, 4, 8, 212, 22, 0, // Skip to: 12450
/* 6606 */    MCD::OPC_Decode, 207, 4, 70, // Opcode: MOV16fb
/* 6610 */    MCD::OPC_FilterValue, 1, 203, 22, 0, // Skip to: 12450
/* 6615 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6618 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6627
/* 6623 */    MCD::OPC_Decode, 161, 4, 85, // Opcode: MOV16bb
/* 6627 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6636
/* 6632 */    MCD::OPC_Decode, 144, 5, 86, // Opcode: MOV16qb
/* 6636 */    MCD::OPC_FilterValue, 3, 177, 22, 0, // Skip to: 12450
/* 6641 */    MCD::OPC_CheckField, 56, 4, 8, 170, 22, 0, // Skip to: 12450
/* 6648 */    MCD::OPC_Decode, 233, 4, 87, // Opcode: MOV16kb
/* 6652 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 6718
/* 6657 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6660 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6676
/* 6665 */    MCD::OPC_CheckField, 40, 4, 8, 146, 22, 0, // Skip to: 12450
/* 6672 */    MCD::OPC_Decode, 217, 4, 71, // Opcode: MOV16fq
/* 6676 */    MCD::OPC_FilterValue, 1, 137, 22, 0, // Skip to: 12450
/* 6681 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6684 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6693
/* 6689 */    MCD::OPC_Decode, 171, 4, 88, // Opcode: MOV16bq
/* 6693 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6702
/* 6698 */    MCD::OPC_Decode, 154, 5, 89, // Opcode: MOV16qq
/* 6702 */    MCD::OPC_FilterValue, 3, 111, 22, 0, // Skip to: 12450
/* 6707 */    MCD::OPC_CheckField, 40, 4, 8, 104, 22, 0, // Skip to: 12450
/* 6714 */    MCD::OPC_Decode, 243, 4, 90, // Opcode: MOV16kq
/* 6718 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 6812
/* 6723 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6726 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 6749
/* 6731 */    MCD::OPC_CheckField, 40, 4, 8, 80, 22, 0, // Skip to: 12450
/* 6738 */    MCD::OPC_CheckField, 24, 4, 8, 73, 22, 0, // Skip to: 12450
/* 6745 */    MCD::OPC_Decode, 214, 4, 72, // Opcode: MOV16fk
/* 6749 */    MCD::OPC_FilterValue, 1, 64, 22, 0, // Skip to: 12450
/* 6754 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6757 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 6773
/* 6762 */    MCD::OPC_CheckField, 24, 4, 8, 49, 22, 0, // Skip to: 12450
/* 6769 */    MCD::OPC_Decode, 168, 4, 91, // Opcode: MOV16bk
/* 6773 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 6789
/* 6778 */    MCD::OPC_CheckField, 24, 4, 8, 33, 22, 0, // Skip to: 12450
/* 6785 */    MCD::OPC_Decode, 151, 5, 92, // Opcode: MOV16qk
/* 6789 */    MCD::OPC_FilterValue, 3, 24, 22, 0, // Skip to: 12450
/* 6794 */    MCD::OPC_CheckField, 40, 4, 8, 17, 22, 0, // Skip to: 12450
/* 6801 */    MCD::OPC_CheckField, 24, 4, 8, 10, 22, 0, // Skip to: 12450
/* 6808 */    MCD::OPC_Decode, 240, 4, 93, // Opcode: MOV16kk
/* 6812 */    MCD::OPC_FilterValue, 4, 1, 22, 0, // Skip to: 12450
/* 6817 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6820 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6836
/* 6825 */    MCD::OPC_CheckField, 40, 4, 8, 242, 21, 0, // Skip to: 12450
/* 6832 */    MCD::OPC_Decode, 212, 4, 71, // Opcode: MOV16fi
/* 6836 */    MCD::OPC_FilterValue, 1, 233, 21, 0, // Skip to: 12450
/* 6841 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6844 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6853
/* 6849 */    MCD::OPC_Decode, 166, 4, 88, // Opcode: MOV16bi
/* 6853 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6862
/* 6858 */    MCD::OPC_Decode, 149, 5, 89, // Opcode: MOV16qi
/* 6862 */    MCD::OPC_FilterValue, 3, 207, 21, 0, // Skip to: 12450
/* 6867 */    MCD::OPC_CheckField, 40, 4, 8, 200, 21, 0, // Skip to: 12450
/* 6874 */    MCD::OPC_Decode, 238, 4, 90, // Opcode: MOV16ki
/* 6878 */    MCD::OPC_FilterValue, 4, 114, 4, 0, // Skip to: 8021
/* 6883 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 6886 */    MCD::OPC_FilterValue, 0, 23, 0, 0, // Skip to: 6914
/* 6891 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6894 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6904
/* 6899 */    MCD::OPC_Decode, 190, 7, 169, 1, // Opcode: NEGX8d
/* 6904 */    MCD::OPC_FilterValue, 2, 165, 21, 0, // Skip to: 12450
/* 6909 */    MCD::OPC_Decode, 187, 7, 169, 1, // Opcode: NEG8d
/* 6914 */    MCD::OPC_FilterValue, 4, 23, 0, 0, // Skip to: 6942
/* 6919 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6922 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6932
/* 6927 */    MCD::OPC_Decode, 188, 7, 170, 1, // Opcode: NEGX16d
/* 6932 */    MCD::OPC_FilterValue, 2, 137, 21, 0, // Skip to: 12450
/* 6937 */    MCD::OPC_Decode, 185, 7, 170, 1, // Opcode: NEG16d
/* 6942 */    MCD::OPC_FilterValue, 7, 37, 0, 0, // Skip to: 6984
/* 6947 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 6950 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 6967
/* 6955 */    MCD::OPC_CheckField, 9, 3, 7, 112, 21, 0, // Skip to: 12450
/* 6962 */    MCD::OPC_Decode, 191, 7, 171, 1, // Opcode: NOP
/* 6967 */    MCD::OPC_FilterValue, 5, 102, 21, 0, // Skip to: 12450
/* 6972 */    MCD::OPC_CheckField, 9, 3, 7, 95, 21, 0, // Skip to: 12450
/* 6979 */    MCD::OPC_Decode, 245, 7, 171, 1, // Opcode: RTS
/* 6984 */    MCD::OPC_FilterValue, 8, 40, 0, 0, // Skip to: 7029
/* 6989 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6992 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7002
/* 6997 */    MCD::OPC_Decode, 189, 7, 172, 1, // Opcode: NEGX32d
/* 7002 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7012
/* 7007 */    MCD::OPC_Decode, 186, 7, 172, 1, // Opcode: NEG32d
/* 7012 */    MCD::OPC_FilterValue, 4, 57, 21, 0, // Skip to: 12450
/* 7017 */    MCD::OPC_CheckField, 3, 1, 0, 50, 21, 0, // Skip to: 12450
/* 7024 */    MCD::OPC_Decode, 255, 3, 173, 1, // Opcode: EXT16
/* 7029 */    MCD::OPC_FilterValue, 9, 72, 0, 0, // Skip to: 7106
/* 7034 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7037 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 7063
/* 7042 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7045 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7054
/* 7050 */    MCD::OPC_Decode, 156, 7, 16, // Opcode: MOVM16jm
/* 7054 */    MCD::OPC_FilterValue, 1, 15, 21, 0, // Skip to: 12450
/* 7059 */    MCD::OPC_Decode, 166, 7, 16, // Opcode: MOVM16om
/* 7063 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 7089
/* 7068 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7071 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7080
/* 7076 */    MCD::OPC_Decode, 161, 7, 17, // Opcode: MOVM16mj
/* 7080 */    MCD::OPC_FilterValue, 1, 245, 20, 0, // Skip to: 12450
/* 7085 */    MCD::OPC_Decode, 163, 7, 17, // Opcode: MOVM16mo
/* 7089 */    MCD::OPC_FilterValue, 7, 236, 20, 0, // Skip to: 12450
/* 7094 */    MCD::OPC_CheckField, 3, 1, 0, 229, 20, 0, // Skip to: 12450
/* 7101 */    MCD::OPC_Decode, 213, 3, 174, 1, // Opcode: CALLj
/* 7106 */    MCD::OPC_FilterValue, 10, 55, 0, 0, // Skip to: 7166
/* 7111 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7114 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 7140
/* 7119 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7122 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7131
/* 7127 */    MCD::OPC_Decode, 154, 7, 16, // Opcode: MOVM16em
/* 7131 */    MCD::OPC_FilterValue, 6, 194, 20, 0, // Skip to: 12450
/* 7136 */    MCD::OPC_Decode, 159, 7, 17, // Opcode: MOVM16me
/* 7140 */    MCD::OPC_FilterValue, 1, 185, 20, 0, // Skip to: 12450
/* 7145 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7148 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7157
/* 7153 */    MCD::OPC_Decode, 167, 7, 18, // Opcode: MOVM16pm
/* 7157 */    MCD::OPC_FilterValue, 6, 168, 20, 0, // Skip to: 12450
/* 7162 */    MCD::OPC_Decode, 164, 7, 19, // Opcode: MOVM16mp
/* 7166 */    MCD::OPC_FilterValue, 11, 180, 0, 0, // Skip to: 7351
/* 7171 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7174 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 7240
/* 7179 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7182 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7198
/* 7187 */    MCD::OPC_CheckField, 40, 4, 8, 136, 20, 0, // Skip to: 12450
/* 7194 */    MCD::OPC_Decode, 155, 7, 20, // Opcode: MOVM16fm
/* 7198 */    MCD::OPC_FilterValue, 1, 127, 20, 0, // Skip to: 12450
/* 7203 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7206 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7215
/* 7211 */    MCD::OPC_Decode, 153, 7, 88, // Opcode: MOVM16bm
/* 7215 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7224
/* 7220 */    MCD::OPC_Decode, 168, 7, 89, // Opcode: MOVM16qm
/* 7224 */    MCD::OPC_FilterValue, 3, 101, 20, 0, // Skip to: 12450
/* 7229 */    MCD::OPC_CheckField, 40, 4, 8, 94, 20, 0, // Skip to: 12450
/* 7236 */    MCD::OPC_Decode, 157, 7, 90, // Opcode: MOVM16km
/* 7240 */    MCD::OPC_FilterValue, 6, 61, 0, 0, // Skip to: 7306
/* 7245 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7248 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7264
/* 7253 */    MCD::OPC_CheckField, 40, 4, 8, 70, 20, 0, // Skip to: 12450
/* 7260 */    MCD::OPC_Decode, 160, 7, 21, // Opcode: MOVM16mf
/* 7264 */    MCD::OPC_FilterValue, 1, 61, 20, 0, // Skip to: 12450
/* 7269 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7272 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7281
/* 7277 */    MCD::OPC_Decode, 158, 7, 22, // Opcode: MOVM16mb
/* 7281 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7290
/* 7286 */    MCD::OPC_Decode, 165, 7, 23, // Opcode: MOVM16mq
/* 7290 */    MCD::OPC_FilterValue, 3, 35, 20, 0, // Skip to: 12450
/* 7295 */    MCD::OPC_CheckField, 40, 4, 8, 28, 20, 0, // Skip to: 12450
/* 7302 */    MCD::OPC_Decode, 162, 7, 24, // Opcode: MOVM16mk
/* 7306 */    MCD::OPC_FilterValue, 7, 19, 20, 0, // Skip to: 12450
/* 7311 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 7314 */    MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 7324
/* 7319 */    MCD::OPC_Decode, 212, 3, 175, 1, // Opcode: CALLb
/* 7324 */    MCD::OPC_FilterValue, 10, 5, 0, 0, // Skip to: 7334
/* 7329 */    MCD::OPC_Decode, 215, 3, 176, 1, // Opcode: CALLq
/* 7334 */    MCD::OPC_FilterValue, 11, 247, 19, 0, // Skip to: 12450
/* 7339 */    MCD::OPC_CheckField, 24, 4, 8, 240, 19, 0, // Skip to: 12450
/* 7346 */    MCD::OPC_Decode, 214, 3, 177, 1, // Opcode: CALLk
/* 7351 */    MCD::OPC_FilterValue, 12, 54, 0, 0, // Skip to: 7410
/* 7356 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7359 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 7376
/* 7364 */    MCD::OPC_CheckField, 3, 1, 0, 215, 19, 0, // Skip to: 12450
/* 7371 */    MCD::OPC_Decode, 183, 4, 178, 1, // Opcode: MOV16dc
/* 7376 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 7393
/* 7381 */    MCD::OPC_CheckField, 3, 1, 0, 198, 19, 0, // Skip to: 12450
/* 7388 */    MCD::OPC_Decode, 174, 4, 179, 1, // Opcode: MOV16cd
/* 7393 */    MCD::OPC_FilterValue, 4, 188, 19, 0, // Skip to: 12450
/* 7398 */    MCD::OPC_CheckField, 3, 1, 0, 181, 19, 0, // Skip to: 12450
/* 7405 */    MCD::OPC_Decode, 128, 4, 180, 1, // Opcode: EXT32
/* 7410 */    MCD::OPC_FilterValue, 13, 128, 0, 0, // Skip to: 7543
/* 7415 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7418 */    MCD::OPC_FilterValue, 1, 23, 0, 0, // Skip to: 7446
/* 7423 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7426 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7436
/* 7431 */    MCD::OPC_Decode, 221, 4, 181, 1, // Opcode: MOV16jc
/* 7436 */    MCD::OPC_FilterValue, 1, 145, 19, 0, // Skip to: 12450
/* 7441 */    MCD::OPC_Decode, 247, 4, 181, 1, // Opcode: MOV16oc
/* 7446 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 7474
/* 7451 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7454 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7464
/* 7459 */    MCD::OPC_Decode, 177, 4, 179, 1, // Opcode: MOV16cj
/* 7464 */    MCD::OPC_FilterValue, 1, 117, 19, 0, // Skip to: 12450
/* 7469 */    MCD::OPC_Decode, 179, 4, 179, 1, // Opcode: MOV16co
/* 7474 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 7500
/* 7479 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7482 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7491
/* 7487 */    MCD::OPC_Decode, 172, 7, 16, // Opcode: MOVM32jm
/* 7491 */    MCD::OPC_FilterValue, 1, 90, 19, 0, // Skip to: 12450
/* 7496 */    MCD::OPC_Decode, 182, 7, 16, // Opcode: MOVM32om
/* 7500 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 7526
/* 7505 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7508 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7517
/* 7513 */    MCD::OPC_Decode, 177, 7, 17, // Opcode: MOVM32mj
/* 7517 */    MCD::OPC_FilterValue, 1, 64, 19, 0, // Skip to: 12450
/* 7522 */    MCD::OPC_Decode, 179, 7, 17, // Opcode: MOVM32mo
/* 7526 */    MCD::OPC_FilterValue, 7, 55, 19, 0, // Skip to: 12450
/* 7531 */    MCD::OPC_CheckField, 3, 1, 0, 48, 19, 0, // Skip to: 12450
/* 7538 */    MCD::OPC_Decode, 129, 4, 174, 1, // Opcode: JMP32j
/* 7543 */    MCD::OPC_FilterValue, 14, 111, 0, 0, // Skip to: 7659
/* 7548 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7551 */    MCD::OPC_FilterValue, 1, 23, 0, 0, // Skip to: 7579
/* 7556 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7559 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7569
/* 7564 */    MCD::OPC_Decode, 195, 4, 181, 1, // Opcode: MOV16ec
/* 7569 */    MCD::OPC_FilterValue, 1, 12, 19, 0, // Skip to: 12450
/* 7574 */    MCD::OPC_Decode, 132, 5, 182, 1, // Opcode: MOV16pc
/* 7579 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 7607
/* 7584 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7587 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7597
/* 7592 */    MCD::OPC_Decode, 175, 4, 179, 1, // Opcode: MOV16ce
/* 7597 */    MCD::OPC_FilterValue, 1, 240, 18, 0, // Skip to: 12450
/* 7602 */    MCD::OPC_Decode, 180, 4, 179, 1, // Opcode: MOV16cp
/* 7607 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 7633
/* 7612 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7615 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7624
/* 7620 */    MCD::OPC_Decode, 170, 7, 16, // Opcode: MOVM32em
/* 7624 */    MCD::OPC_FilterValue, 1, 213, 18, 0, // Skip to: 12450
/* 7629 */    MCD::OPC_Decode, 183, 7, 18, // Opcode: MOVM32pm
/* 7633 */    MCD::OPC_FilterValue, 6, 204, 18, 0, // Skip to: 12450
/* 7638 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7641 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7650
/* 7646 */    MCD::OPC_Decode, 175, 7, 17, // Opcode: MOVM32me
/* 7650 */    MCD::OPC_FilterValue, 1, 187, 18, 0, // Skip to: 12450
/* 7655 */    MCD::OPC_Decode, 180, 7, 19, // Opcode: MOVM32mp
/* 7659 */    MCD::OPC_FilterValue, 15, 19, 1, 0, // Skip to: 7939
/* 7664 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7667 */    MCD::OPC_FilterValue, 1, 65, 0, 0, // Skip to: 7737
/* 7672 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7675 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 7692
/* 7680 */    MCD::OPC_CheckField, 24, 4, 8, 155, 18, 0, // Skip to: 12450
/* 7687 */    MCD::OPC_Decode, 208, 4, 183, 1, // Opcode: MOV16fc
/* 7692 */    MCD::OPC_FilterValue, 1, 145, 18, 0, // Skip to: 12450
/* 7697 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7700 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 7710
/* 7705 */    MCD::OPC_Decode, 162, 4, 184, 1, // Opcode: MOV16bc
/* 7710 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7720
/* 7715 */    MCD::OPC_Decode, 145, 5, 185, 1, // Opcode: MOV16qc
/* 7720 */    MCD::OPC_FilterValue, 3, 117, 18, 0, // Skip to: 12450
/* 7725 */    MCD::OPC_CheckField, 24, 4, 8, 110, 18, 0, // Skip to: 12450
/* 7732 */    MCD::OPC_Decode, 234, 4, 186, 1, // Opcode: MOV16kc
/* 7737 */    MCD::OPC_FilterValue, 2, 65, 0, 0, // Skip to: 7807
/* 7742 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7745 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 7762
/* 7750 */    MCD::OPC_CheckField, 24, 4, 8, 85, 18, 0, // Skip to: 12450
/* 7757 */    MCD::OPC_Decode, 176, 4, 179, 1, // Opcode: MOV16cf
/* 7762 */    MCD::OPC_FilterValue, 1, 75, 18, 0, // Skip to: 12450
/* 7767 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7770 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 7780
/* 7775 */    MCD::OPC_Decode, 173, 4, 179, 1, // Opcode: MOV16cb
/* 7780 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7790
/* 7785 */    MCD::OPC_Decode, 181, 4, 179, 1, // Opcode: MOV16cq
/* 7790 */    MCD::OPC_FilterValue, 3, 47, 18, 0, // Skip to: 12450
/* 7795 */    MCD::OPC_CheckField, 24, 4, 8, 40, 18, 0, // Skip to: 12450
/* 7802 */    MCD::OPC_Decode, 178, 4, 179, 1, // Opcode: MOV16ck
/* 7807 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 7873
/* 7812 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7815 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7831
/* 7820 */    MCD::OPC_CheckField, 40, 4, 8, 15, 18, 0, // Skip to: 12450
/* 7827 */    MCD::OPC_Decode, 171, 7, 20, // Opcode: MOVM32fm
/* 7831 */    MCD::OPC_FilterValue, 1, 6, 18, 0, // Skip to: 12450
/* 7836 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7839 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7848
/* 7844 */    MCD::OPC_Decode, 169, 7, 88, // Opcode: MOVM32bm
/* 7848 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7857
/* 7853 */    MCD::OPC_Decode, 184, 7, 89, // Opcode: MOVM32qm
/* 7857 */    MCD::OPC_FilterValue, 3, 236, 17, 0, // Skip to: 12450
/* 7862 */    MCD::OPC_CheckField, 40, 4, 8, 229, 17, 0, // Skip to: 12450
/* 7869 */    MCD::OPC_Decode, 173, 7, 90, // Opcode: MOVM32km
/* 7873 */    MCD::OPC_FilterValue, 6, 220, 17, 0, // Skip to: 12450
/* 7878 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7881 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7897
/* 7886 */    MCD::OPC_CheckField, 40, 4, 8, 205, 17, 0, // Skip to: 12450
/* 7893 */    MCD::OPC_Decode, 176, 7, 21, // Opcode: MOVM32mf
/* 7897 */    MCD::OPC_FilterValue, 1, 196, 17, 0, // Skip to: 12450
/* 7902 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7905 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7914
/* 7910 */    MCD::OPC_Decode, 174, 7, 22, // Opcode: MOVM32mb
/* 7914 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7923
/* 7919 */    MCD::OPC_Decode, 181, 7, 23, // Opcode: MOVM32mq
/* 7923 */    MCD::OPC_FilterValue, 3, 170, 17, 0, // Skip to: 12450
/* 7928 */    MCD::OPC_CheckField, 40, 4, 8, 163, 17, 0, // Skip to: 12450
/* 7935 */    MCD::OPC_Decode, 178, 7, 24, // Opcode: MOVM32mk
/* 7939 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 7955
/* 7944 */    MCD::OPC_CheckField, 3, 1, 1, 147, 17, 0, // Skip to: 12450
/* 7951 */    MCD::OPC_Decode, 133, 4, 52, // Opcode: LEA32p
/* 7955 */    MCD::OPC_FilterValue, 31, 138, 17, 0, // Skip to: 12450
/* 7960 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7963 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7979
/* 7968 */    MCD::OPC_CheckField, 24, 4, 8, 123, 17, 0, // Skip to: 12450
/* 7975 */    MCD::OPC_Decode, 131, 4, 53, // Opcode: LEA32f
/* 7979 */    MCD::OPC_FilterValue, 1, 114, 17, 0, // Skip to: 12450
/* 7984 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7987 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7996
/* 7992 */    MCD::OPC_Decode, 130, 4, 54, // Opcode: LEA32b
/* 7996 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8005
/* 8001 */    MCD::OPC_Decode, 134, 4, 55, // Opcode: LEA32q
/* 8005 */    MCD::OPC_FilterValue, 3, 88, 17, 0, // Skip to: 12450
/* 8010 */    MCD::OPC_CheckField, 24, 4, 8, 81, 17, 0, // Skip to: 12450
/* 8017 */    MCD::OPC_Decode, 132, 4, 56, // Opcode: LEA32k
/* 8021 */    MCD::OPC_FilterValue, 5, 203, 2, 0, // Skip to: 8741
/* 8026 */    MCD::OPC_ExtractField, 4, 8,  // Inst{11-4} ...
/* 8029 */    MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 8039
/* 8034 */    MCD::OPC_Decode, 133, 8, 187, 1, // Opcode: SETd8t
/* 8039 */    MCD::OPC_FilterValue, 13, 12, 0, 0, // Skip to: 8056
/* 8044 */    MCD::OPC_CheckField, 3, 1, 0, 47, 17, 0, // Skip to: 12450
/* 8051 */    MCD::OPC_Decode, 149, 8, 174, 1, // Opcode: SETj8t
/* 8056 */    MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 8072
/* 8061 */    MCD::OPC_CheckField, 3, 1, 1, 30, 17, 0, // Skip to: 12450
/* 8068 */    MCD::OPC_Decode, 165, 8, 17, // Opcode: SETp8t
/* 8072 */    MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 8082
/* 8077 */    MCD::OPC_Decode, 251, 7, 187, 1, // Opcode: SETd8f
/* 8082 */    MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 8099
/* 8087 */    MCD::OPC_CheckField, 3, 1, 0, 4, 17, 0, // Skip to: 12450
/* 8094 */    MCD::OPC_Decode, 139, 8, 174, 1, // Opcode: SETj8f
/* 8099 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 8115
/* 8104 */    MCD::OPC_CheckField, 3, 1, 1, 243, 16, 0, // Skip to: 12450
/* 8111 */    MCD::OPC_Decode, 155, 8, 17, // Opcode: SETp8f
/* 8115 */    MCD::OPC_FilterValue, 44, 5, 0, 0, // Skip to: 8125
/* 8120 */    MCD::OPC_Decode, 254, 7, 187, 1, // Opcode: SETd8hi
/* 8125 */    MCD::OPC_FilterValue, 45, 12, 0, 0, // Skip to: 8142
/* 8130 */    MCD::OPC_CheckField, 3, 1, 0, 217, 16, 0, // Skip to: 12450
/* 8137 */    MCD::OPC_Decode, 142, 8, 174, 1, // Opcode: SETj8hi
/* 8142 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 8158
/* 8147 */    MCD::OPC_CheckField, 3, 1, 1, 200, 16, 0, // Skip to: 12450
/* 8154 */    MCD::OPC_Decode, 158, 8, 17, // Opcode: SETp8hi
/* 8158 */    MCD::OPC_FilterValue, 60, 5, 0, 0, // Skip to: 8168
/* 8163 */    MCD::OPC_Decode, 128, 8, 187, 1, // Opcode: SETd8ls
/* 8168 */    MCD::OPC_FilterValue, 61, 12, 0, 0, // Skip to: 8185
/* 8173 */    MCD::OPC_CheckField, 3, 1, 0, 174, 16, 0, // Skip to: 12450
/* 8180 */    MCD::OPC_Decode, 144, 8, 174, 1, // Opcode: SETj8ls
/* 8185 */    MCD::OPC_FilterValue, 62, 11, 0, 0, // Skip to: 8201
/* 8190 */    MCD::OPC_CheckField, 3, 1, 1, 157, 16, 0, // Skip to: 12450
/* 8197 */    MCD::OPC_Decode, 160, 8, 17, // Opcode: SETp8ls
/* 8201 */    MCD::OPC_FilterValue, 76, 5, 0, 0, // Skip to: 8211
/* 8206 */    MCD::OPC_Decode, 248, 7, 187, 1, // Opcode: SETd8cc
/* 8211 */    MCD::OPC_FilterValue, 77, 12, 0, 0, // Skip to: 8228
/* 8216 */    MCD::OPC_CheckField, 3, 1, 0, 131, 16, 0, // Skip to: 12450
/* 8223 */    MCD::OPC_Decode, 136, 8, 174, 1, // Opcode: SETj8cc
/* 8228 */    MCD::OPC_FilterValue, 78, 11, 0, 0, // Skip to: 8244
/* 8233 */    MCD::OPC_CheckField, 3, 1, 1, 114, 16, 0, // Skip to: 12450
/* 8240 */    MCD::OPC_Decode, 152, 8, 17, // Opcode: SETp8cc
/* 8244 */    MCD::OPC_FilterValue, 92, 5, 0, 0, // Skip to: 8254
/* 8249 */    MCD::OPC_Decode, 249, 7, 187, 1, // Opcode: SETd8cs
/* 8254 */    MCD::OPC_FilterValue, 93, 12, 0, 0, // Skip to: 8271
/* 8259 */    MCD::OPC_CheckField, 3, 1, 0, 88, 16, 0, // Skip to: 12450
/* 8266 */    MCD::OPC_Decode, 137, 8, 174, 1, // Opcode: SETj8cs
/* 8271 */    MCD::OPC_FilterValue, 94, 11, 0, 0, // Skip to: 8287
/* 8276 */    MCD::OPC_CheckField, 3, 1, 1, 71, 16, 0, // Skip to: 12450
/* 8283 */    MCD::OPC_Decode, 153, 8, 17, // Opcode: SETp8cs
/* 8287 */    MCD::OPC_FilterValue, 108, 5, 0, 0, // Skip to: 8297
/* 8292 */    MCD::OPC_Decode, 131, 8, 187, 1, // Opcode: SETd8ne
/* 8297 */    MCD::OPC_FilterValue, 109, 12, 0, 0, // Skip to: 8314
/* 8302 */    MCD::OPC_CheckField, 3, 1, 0, 45, 16, 0, // Skip to: 12450
/* 8309 */    MCD::OPC_Decode, 147, 8, 174, 1, // Opcode: SETj8ne
/* 8314 */    MCD::OPC_FilterValue, 110, 11, 0, 0, // Skip to: 8330
/* 8319 */    MCD::OPC_CheckField, 3, 1, 1, 28, 16, 0, // Skip to: 12450
/* 8326 */    MCD::OPC_Decode, 163, 8, 17, // Opcode: SETp8ne
/* 8330 */    MCD::OPC_FilterValue, 124, 5, 0, 0, // Skip to: 8340
/* 8335 */    MCD::OPC_Decode, 250, 7, 187, 1, // Opcode: SETd8eq
/* 8340 */    MCD::OPC_FilterValue, 125, 12, 0, 0, // Skip to: 8357
/* 8345 */    MCD::OPC_CheckField, 3, 1, 0, 2, 16, 0, // Skip to: 12450
/* 8352 */    MCD::OPC_Decode, 138, 8, 174, 1, // Opcode: SETj8eq
/* 8357 */    MCD::OPC_FilterValue, 126, 11, 0, 0, // Skip to: 8373
/* 8362 */    MCD::OPC_CheckField, 3, 1, 1, 241, 15, 0, // Skip to: 12450
/* 8369 */    MCD::OPC_Decode, 154, 8, 17, // Opcode: SETp8eq
/* 8373 */    MCD::OPC_FilterValue, 140, 1, 5, 0, 0, // Skip to: 8384
/* 8379 */    MCD::OPC_Decode, 134, 8, 187, 1, // Opcode: SETd8vc
/* 8384 */    MCD::OPC_FilterValue, 141, 1, 12, 0, 0, // Skip to: 8402
/* 8390 */    MCD::OPC_CheckField, 3, 1, 0, 213, 15, 0, // Skip to: 12450
/* 8397 */    MCD::OPC_Decode, 150, 8, 174, 1, // Opcode: SETj8vc
/* 8402 */    MCD::OPC_FilterValue, 142, 1, 11, 0, 0, // Skip to: 8419
/* 8408 */    MCD::OPC_CheckField, 3, 1, 1, 195, 15, 0, // Skip to: 12450
/* 8415 */    MCD::OPC_Decode, 166, 8, 17, // Opcode: SETp8vc
/* 8419 */    MCD::OPC_FilterValue, 156, 1, 5, 0, 0, // Skip to: 8430
/* 8425 */    MCD::OPC_Decode, 135, 8, 187, 1, // Opcode: SETd8vs
/* 8430 */    MCD::OPC_FilterValue, 157, 1, 12, 0, 0, // Skip to: 8448
/* 8436 */    MCD::OPC_CheckField, 3, 1, 0, 167, 15, 0, // Skip to: 12450
/* 8443 */    MCD::OPC_Decode, 151, 8, 174, 1, // Opcode: SETj8vs
/* 8448 */    MCD::OPC_FilterValue, 158, 1, 11, 0, 0, // Skip to: 8465
/* 8454 */    MCD::OPC_CheckField, 3, 1, 1, 149, 15, 0, // Skip to: 12450
/* 8461 */    MCD::OPC_Decode, 167, 8, 17, // Opcode: SETp8vs
/* 8465 */    MCD::OPC_FilterValue, 172, 1, 5, 0, 0, // Skip to: 8476
/* 8471 */    MCD::OPC_Decode, 132, 8, 187, 1, // Opcode: SETd8pl
/* 8476 */    MCD::OPC_FilterValue, 173, 1, 12, 0, 0, // Skip to: 8494
/* 8482 */    MCD::OPC_CheckField, 3, 1, 0, 121, 15, 0, // Skip to: 12450
/* 8489 */    MCD::OPC_Decode, 148, 8, 174, 1, // Opcode: SETj8pl
/* 8494 */    MCD::OPC_FilterValue, 174, 1, 11, 0, 0, // Skip to: 8511
/* 8500 */    MCD::OPC_CheckField, 3, 1, 1, 103, 15, 0, // Skip to: 12450
/* 8507 */    MCD::OPC_Decode, 164, 8, 17, // Opcode: SETp8pl
/* 8511 */    MCD::OPC_FilterValue, 188, 1, 5, 0, 0, // Skip to: 8522
/* 8517 */    MCD::OPC_Decode, 130, 8, 187, 1, // Opcode: SETd8mi
/* 8522 */    MCD::OPC_FilterValue, 189, 1, 12, 0, 0, // Skip to: 8540
/* 8528 */    MCD::OPC_CheckField, 3, 1, 0, 75, 15, 0, // Skip to: 12450
/* 8535 */    MCD::OPC_Decode, 146, 8, 174, 1, // Opcode: SETj8mi
/* 8540 */    MCD::OPC_FilterValue, 190, 1, 11, 0, 0, // Skip to: 8557
/* 8546 */    MCD::OPC_CheckField, 3, 1, 1, 57, 15, 0, // Skip to: 12450
/* 8553 */    MCD::OPC_Decode, 162, 8, 17, // Opcode: SETp8mi
/* 8557 */    MCD::OPC_FilterValue, 204, 1, 5, 0, 0, // Skip to: 8568
/* 8563 */    MCD::OPC_Decode, 252, 7, 187, 1, // Opcode: SETd8ge
/* 8568 */    MCD::OPC_FilterValue, 205, 1, 12, 0, 0, // Skip to: 8586
/* 8574 */    MCD::OPC_CheckField, 3, 1, 0, 29, 15, 0, // Skip to: 12450
/* 8581 */    MCD::OPC_Decode, 140, 8, 174, 1, // Opcode: SETj8ge
/* 8586 */    MCD::OPC_FilterValue, 206, 1, 11, 0, 0, // Skip to: 8603
/* 8592 */    MCD::OPC_CheckField, 3, 1, 1, 11, 15, 0, // Skip to: 12450
/* 8599 */    MCD::OPC_Decode, 156, 8, 17, // Opcode: SETp8ge
/* 8603 */    MCD::OPC_FilterValue, 220, 1, 5, 0, 0, // Skip to: 8614
/* 8609 */    MCD::OPC_Decode, 129, 8, 187, 1, // Opcode: SETd8lt
/* 8614 */    MCD::OPC_FilterValue, 221, 1, 12, 0, 0, // Skip to: 8632
/* 8620 */    MCD::OPC_CheckField, 3, 1, 0, 239, 14, 0, // Skip to: 12450
/* 8627 */    MCD::OPC_Decode, 145, 8, 174, 1, // Opcode: SETj8lt
/* 8632 */    MCD::OPC_FilterValue, 222, 1, 11, 0, 0, // Skip to: 8649
/* 8638 */    MCD::OPC_CheckField, 3, 1, 1, 221, 14, 0, // Skip to: 12450
/* 8645 */    MCD::OPC_Decode, 161, 8, 17, // Opcode: SETp8lt
/* 8649 */    MCD::OPC_FilterValue, 236, 1, 5, 0, 0, // Skip to: 8660
/* 8655 */    MCD::OPC_Decode, 253, 7, 187, 1, // Opcode: SETd8gt
/* 8660 */    MCD::OPC_FilterValue, 237, 1, 12, 0, 0, // Skip to: 8678
/* 8666 */    MCD::OPC_CheckField, 3, 1, 0, 193, 14, 0, // Skip to: 12450
/* 8673 */    MCD::OPC_Decode, 141, 8, 174, 1, // Opcode: SETj8gt
/* 8678 */    MCD::OPC_FilterValue, 238, 1, 11, 0, 0, // Skip to: 8695
/* 8684 */    MCD::OPC_CheckField, 3, 1, 1, 175, 14, 0, // Skip to: 12450
/* 8691 */    MCD::OPC_Decode, 157, 8, 17, // Opcode: SETp8gt
/* 8695 */    MCD::OPC_FilterValue, 252, 1, 5, 0, 0, // Skip to: 8706
/* 8701 */    MCD::OPC_Decode, 255, 7, 187, 1, // Opcode: SETd8le
/* 8706 */    MCD::OPC_FilterValue, 253, 1, 12, 0, 0, // Skip to: 8724
/* 8712 */    MCD::OPC_CheckField, 3, 1, 0, 147, 14, 0, // Skip to: 12450
/* 8719 */    MCD::OPC_Decode, 143, 8, 174, 1, // Opcode: SETj8le
/* 8724 */    MCD::OPC_FilterValue, 254, 1, 136, 14, 0, // Skip to: 12450
/* 8730 */    MCD::OPC_CheckField, 3, 1, 1, 129, 14, 0, // Skip to: 12450
/* 8737 */    MCD::OPC_Decode, 159, 8, 17, // Opcode: SETp8le
/* 8741 */    MCD::OPC_FilterValue, 6, 77, 1, 0, // Skip to: 9079
/* 8746 */    MCD::OPC_ExtractField, 8, 4,  // Inst{11-8} ...
/* 8749 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 8771
/* 8754 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8766
/* 8761 */    MCD::OPC_Decode, 166, 3, 176, 1, // Opcode: BRA16
/* 8766 */    MCD::OPC_Decode, 167, 3, 188, 1, // Opcode: BRA8
/* 8771 */    MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 8793
/* 8776 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8788
/* 8783 */    MCD::OPC_Decode, 194, 3, 176, 1, // Opcode: Bhi16
/* 8788 */    MCD::OPC_Decode, 195, 3, 188, 1, // Opcode: Bhi8
/* 8793 */    MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 8815
/* 8798 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8810
/* 8805 */    MCD::OPC_Decode, 198, 3, 176, 1, // Opcode: Bls16
/* 8810 */    MCD::OPC_Decode, 199, 3, 188, 1, // Opcode: Bls8
/* 8815 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 8837
/* 8820 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8832
/* 8827 */    MCD::OPC_Decode, 184, 3, 176, 1, // Opcode: Bcc16
/* 8832 */    MCD::OPC_Decode, 185, 3, 188, 1, // Opcode: Bcc8
/* 8837 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 8859
/* 8842 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8854
/* 8849 */    MCD::OPC_Decode, 186, 3, 176, 1, // Opcode: Bcs16
/* 8854 */    MCD::OPC_Decode, 187, 3, 188, 1, // Opcode: Bcs8
/* 8859 */    MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 8881
/* 8864 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8876
/* 8871 */    MCD::OPC_Decode, 204, 3, 176, 1, // Opcode: Bne16
/* 8876 */    MCD::OPC_Decode, 205, 3, 188, 1, // Opcode: Bne8
/* 8881 */    MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 8903
/* 8886 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8898
/* 8893 */    MCD::OPC_Decode, 188, 3, 176, 1, // Opcode: Beq16
/* 8898 */    MCD::OPC_Decode, 189, 3, 188, 1, // Opcode: Beq8
/* 8903 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 8925
/* 8908 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8920
/* 8915 */    MCD::OPC_Decode, 208, 3, 176, 1, // Opcode: Bvc16
/* 8920 */    MCD::OPC_Decode, 209, 3, 188, 1, // Opcode: Bvc8
/* 8925 */    MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 8947
/* 8930 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8942
/* 8937 */    MCD::OPC_Decode, 210, 3, 176, 1, // Opcode: Bvs16
/* 8942 */    MCD::OPC_Decode, 211, 3, 188, 1, // Opcode: Bvs8
/* 8947 */    MCD::OPC_FilterValue, 10, 17, 0, 0, // Skip to: 8969
/* 8952 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8964
/* 8959 */    MCD::OPC_Decode, 206, 3, 176, 1, // Opcode: Bpl16
/* 8964 */    MCD::OPC_Decode, 207, 3, 188, 1, // Opcode: Bpl8
/* 8969 */    MCD::OPC_FilterValue, 11, 17, 0, 0, // Skip to: 8991
/* 8974 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8986
/* 8981 */    MCD::OPC_Decode, 202, 3, 176, 1, // Opcode: Bmi16
/* 8986 */    MCD::OPC_Decode, 203, 3, 188, 1, // Opcode: Bmi8
/* 8991 */    MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 9013
/* 8996 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9008
/* 9003 */    MCD::OPC_Decode, 190, 3, 176, 1, // Opcode: Bge16
/* 9008 */    MCD::OPC_Decode, 191, 3, 188, 1, // Opcode: Bge8
/* 9013 */    MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 9035
/* 9018 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9030
/* 9025 */    MCD::OPC_Decode, 200, 3, 176, 1, // Opcode: Blt16
/* 9030 */    MCD::OPC_Decode, 201, 3, 188, 1, // Opcode: Blt8
/* 9035 */    MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 9057
/* 9040 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9052
/* 9047 */    MCD::OPC_Decode, 192, 3, 176, 1, // Opcode: Bgt16
/* 9052 */    MCD::OPC_Decode, 193, 3, 188, 1, // Opcode: Bgt8
/* 9057 */    MCD::OPC_FilterValue, 15, 60, 13, 0, // Skip to: 12450
/* 9062 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9074
/* 9069 */    MCD::OPC_Decode, 196, 3, 176, 1, // Opcode: Ble16
/* 9074 */    MCD::OPC_Decode, 197, 3, 188, 1, // Opcode: Ble8
/* 9079 */    MCD::OPC_FilterValue, 8, 110, 2, 0, // Skip to: 9706
/* 9084 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 9087 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9104
/* 9092 */    MCD::OPC_CheckField, 3, 1, 0, 23, 13, 0, // Skip to: 12450
/* 9099 */    MCD::OPC_Decode, 220, 7, 189, 1, // Opcode: OR8dd
/* 9104 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 9121
/* 9109 */    MCD::OPC_CheckField, 3, 1, 0, 6, 13, 0, // Skip to: 12450
/* 9116 */    MCD::OPC_Decode, 223, 7, 190, 1, // Opcode: OR8dj
/* 9121 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 9138
/* 9126 */    MCD::OPC_CheckField, 3, 1, 1, 245, 12, 0, // Skip to: 12450
/* 9133 */    MCD::OPC_Decode, 225, 7, 191, 1, // Opcode: OR8dp
/* 9138 */    MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 9215
/* 9143 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9146 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9163
/* 9151 */    MCD::OPC_CheckField, 24, 4, 8, 220, 12, 0, // Skip to: 12450
/* 9158 */    MCD::OPC_Decode, 221, 7, 192, 1, // Opcode: OR8df
/* 9163 */    MCD::OPC_FilterValue, 1, 210, 12, 0, // Skip to: 12450
/* 9168 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9171 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9181
/* 9176 */    MCD::OPC_Decode, 226, 7, 193, 1, // Opcode: OR8dq
/* 9181 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9198
/* 9186 */    MCD::OPC_CheckField, 24, 4, 8, 185, 12, 0, // Skip to: 12450
/* 9193 */    MCD::OPC_Decode, 224, 7, 194, 1, // Opcode: OR8dk
/* 9198 */    MCD::OPC_FilterValue, 4, 175, 12, 0, // Skip to: 12450
/* 9203 */    MCD::OPC_CheckField, 24, 8, 0, 168, 12, 0, // Skip to: 12450
/* 9210 */    MCD::OPC_Decode, 222, 7, 195, 1, // Opcode: OR8di
/* 9215 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 9237
/* 9220 */    MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 9232
/* 9227 */    MCD::OPC_Decode, 192, 7, 196, 1, // Opcode: OR16dd
/* 9232 */    MCD::OPC_Decode, 199, 7, 197, 1, // Opcode: OR16dr
/* 9237 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 9254
/* 9242 */    MCD::OPC_CheckField, 3, 1, 0, 129, 12, 0, // Skip to: 12450
/* 9249 */    MCD::OPC_Decode, 195, 7, 198, 1, // Opcode: OR16dj
/* 9254 */    MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 9271
/* 9259 */    MCD::OPC_CheckField, 3, 1, 1, 112, 12, 0, // Skip to: 12450
/* 9266 */    MCD::OPC_Decode, 197, 7, 199, 1, // Opcode: OR16dp
/* 9271 */    MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 9341
/* 9276 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9279 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9296
/* 9284 */    MCD::OPC_CheckField, 24, 4, 8, 87, 12, 0, // Skip to: 12450
/* 9291 */    MCD::OPC_Decode, 193, 7, 200, 1, // Opcode: OR16df
/* 9296 */    MCD::OPC_FilterValue, 1, 77, 12, 0, // Skip to: 12450
/* 9301 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9304 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9314
/* 9309 */    MCD::OPC_Decode, 198, 7, 201, 1, // Opcode: OR16dq
/* 9314 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9331
/* 9319 */    MCD::OPC_CheckField, 24, 4, 8, 52, 12, 0, // Skip to: 12450
/* 9326 */    MCD::OPC_Decode, 196, 7, 202, 1, // Opcode: OR16dk
/* 9331 */    MCD::OPC_FilterValue, 4, 42, 12, 0, // Skip to: 12450
/* 9336 */    MCD::OPC_Decode, 194, 7, 201, 1, // Opcode: OR16di
/* 9341 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 9363
/* 9346 */    MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 9358
/* 9353 */    MCD::OPC_Decode, 206, 7, 203, 1, // Opcode: OR32dd
/* 9358 */    MCD::OPC_Decode, 213, 7, 204, 1, // Opcode: OR32dr
/* 9363 */    MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 9380
/* 9368 */    MCD::OPC_CheckField, 3, 1, 0, 3, 12, 0, // Skip to: 12450
/* 9375 */    MCD::OPC_Decode, 209, 7, 205, 1, // Opcode: OR32dj
/* 9380 */    MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 9397
/* 9385 */    MCD::OPC_CheckField, 3, 1, 1, 242, 11, 0, // Skip to: 12450
/* 9392 */    MCD::OPC_Decode, 211, 7, 206, 1, // Opcode: OR32dp
/* 9397 */    MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 9467
/* 9402 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9405 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9422
/* 9410 */    MCD::OPC_CheckField, 24, 4, 8, 217, 11, 0, // Skip to: 12450
/* 9417 */    MCD::OPC_Decode, 207, 7, 207, 1, // Opcode: OR32df
/* 9422 */    MCD::OPC_FilterValue, 1, 207, 11, 0, // Skip to: 12450
/* 9427 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9430 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9440
/* 9435 */    MCD::OPC_Decode, 212, 7, 208, 1, // Opcode: OR32dq
/* 9440 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9457
/* 9445 */    MCD::OPC_CheckField, 24, 4, 8, 182, 11, 0, // Skip to: 12450
/* 9452 */    MCD::OPC_Decode, 210, 7, 209, 1, // Opcode: OR32dk
/* 9457 */    MCD::OPC_FilterValue, 4, 172, 11, 0, // Skip to: 12450
/* 9462 */    MCD::OPC_Decode, 208, 7, 210, 1, // Opcode: OR32di
/* 9467 */    MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 9484
/* 9472 */    MCD::OPC_CheckField, 3, 1, 0, 155, 11, 0, // Skip to: 12450
/* 9479 */    MCD::OPC_Decode, 227, 8, 211, 1, // Opcode: UDIVd32d16
/* 9484 */    MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 9501
/* 9489 */    MCD::OPC_CheckField, 0, 4, 12, 138, 11, 0, // Skip to: 12450
/* 9496 */    MCD::OPC_Decode, 228, 8, 208, 1, // Opcode: UDIVd32i16
/* 9501 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 9517
/* 9506 */    MCD::OPC_CheckField, 3, 1, 0, 121, 11, 0, // Skip to: 12450
/* 9513 */    MCD::OPC_Decode, 229, 7, 37, // Opcode: OR8jd
/* 9517 */    MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 9533
/* 9522 */    MCD::OPC_CheckField, 3, 1, 1, 105, 11, 0, // Skip to: 12450
/* 9529 */    MCD::OPC_Decode, 231, 7, 38, // Opcode: OR8pd
/* 9533 */    MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 9556
/* 9538 */    MCD::OPC_CheckField, 24, 4, 8, 89, 11, 0, // Skip to: 12450
/* 9545 */    MCD::OPC_CheckField, 3, 1, 0, 82, 11, 0, // Skip to: 12450
/* 9552 */    MCD::OPC_Decode, 227, 7, 39, // Opcode: OR8fd
/* 9556 */    MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 9573
/* 9561 */    MCD::OPC_CheckField, 3, 1, 0, 66, 11, 0, // Skip to: 12450
/* 9568 */    MCD::OPC_Decode, 202, 7, 212, 1, // Opcode: OR16jd
/* 9573 */    MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 9590
/* 9578 */    MCD::OPC_CheckField, 3, 1, 1, 49, 11, 0, // Skip to: 12450
/* 9585 */    MCD::OPC_Decode, 204, 7, 213, 1, // Opcode: OR16pd
/* 9590 */    MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 9614
/* 9595 */    MCD::OPC_CheckField, 24, 4, 8, 32, 11, 0, // Skip to: 12450
/* 9602 */    MCD::OPC_CheckField, 3, 1, 0, 25, 11, 0, // Skip to: 12450
/* 9609 */    MCD::OPC_Decode, 200, 7, 214, 1, // Opcode: OR16fd
/* 9614 */    MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 9631
/* 9619 */    MCD::OPC_CheckField, 3, 1, 0, 8, 11, 0, // Skip to: 12450
/* 9626 */    MCD::OPC_Decode, 216, 7, 215, 1, // Opcode: OR32jd
/* 9631 */    MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 9648
/* 9636 */    MCD::OPC_CheckField, 3, 1, 1, 247, 10, 0, // Skip to: 12450
/* 9643 */    MCD::OPC_Decode, 218, 7, 216, 1, // Opcode: OR32pd
/* 9648 */    MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 9672
/* 9653 */    MCD::OPC_CheckField, 24, 4, 8, 230, 10, 0, // Skip to: 12450
/* 9660 */    MCD::OPC_CheckField, 3, 1, 0, 223, 10, 0, // Skip to: 12450
/* 9667 */    MCD::OPC_Decode, 214, 7, 217, 1, // Opcode: OR32fd
/* 9672 */    MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 9689
/* 9677 */    MCD::OPC_CheckField, 3, 1, 0, 206, 10, 0, // Skip to: 12450
/* 9684 */    MCD::OPC_Decode, 246, 7, 211, 1, // Opcode: SDIVd32d16
/* 9689 */    MCD::OPC_FilterValue, 31, 196, 10, 0, // Skip to: 12450
/* 9694 */    MCD::OPC_CheckField, 0, 4, 12, 189, 10, 0, // Skip to: 12450
/* 9701 */    MCD::OPC_Decode, 247, 7, 208, 1, // Opcode: SDIVd32i16
/* 9706 */    MCD::OPC_FilterValue, 9, 207, 2, 0, // Skip to: 10430
/* 9711 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 9714 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9731
/* 9719 */    MCD::OPC_CheckField, 3, 1, 0, 164, 10, 0, // Skip to: 12450
/* 9726 */    MCD::OPC_Decode, 211, 8, 189, 1, // Opcode: SUB8dd
/* 9731 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 9748
/* 9736 */    MCD::OPC_CheckField, 3, 1, 0, 147, 10, 0, // Skip to: 12450
/* 9743 */    MCD::OPC_Decode, 214, 8, 190, 1, // Opcode: SUB8dj
/* 9748 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 9765
/* 9753 */    MCD::OPC_CheckField, 3, 1, 1, 130, 10, 0, // Skip to: 12450
/* 9760 */    MCD::OPC_Decode, 216, 8, 191, 1, // Opcode: SUB8dp
/* 9765 */    MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 9842
/* 9770 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9773 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9790
/* 9778 */    MCD::OPC_CheckField, 24, 4, 8, 105, 10, 0, // Skip to: 12450
/* 9785 */    MCD::OPC_Decode, 212, 8, 192, 1, // Opcode: SUB8df
/* 9790 */    MCD::OPC_FilterValue, 1, 95, 10, 0, // Skip to: 12450
/* 9795 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9798 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9808
/* 9803 */    MCD::OPC_Decode, 217, 8, 193, 1, // Opcode: SUB8dq
/* 9808 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9825
/* 9813 */    MCD::OPC_CheckField, 24, 4, 8, 70, 10, 0, // Skip to: 12450
/* 9820 */    MCD::OPC_Decode, 215, 8, 194, 1, // Opcode: SUB8dk
/* 9825 */    MCD::OPC_FilterValue, 4, 60, 10, 0, // Skip to: 12450
/* 9830 */    MCD::OPC_CheckField, 24, 8, 0, 53, 10, 0, // Skip to: 12450
/* 9837 */    MCD::OPC_Decode, 213, 8, 195, 1, // Opcode: SUB8di
/* 9842 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 9864
/* 9847 */    MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 9859
/* 9854 */    MCD::OPC_Decode, 176, 8, 196, 1, // Opcode: SUB16dd
/* 9859 */    MCD::OPC_Decode, 183, 8, 197, 1, // Opcode: SUB16dr
/* 9864 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 9881
/* 9869 */    MCD::OPC_CheckField, 3, 1, 0, 14, 10, 0, // Skip to: 12450
/* 9876 */    MCD::OPC_Decode, 179, 8, 198, 1, // Opcode: SUB16dj
/* 9881 */    MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 9898
/* 9886 */    MCD::OPC_CheckField, 3, 1, 1, 253, 9, 0, // Skip to: 12450
/* 9893 */    MCD::OPC_Decode, 181, 8, 199, 1, // Opcode: SUB16dp
/* 9898 */    MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 9968
/* 9903 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9906 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9923
/* 9911 */    MCD::OPC_CheckField, 24, 4, 8, 228, 9, 0, // Skip to: 12450
/* 9918 */    MCD::OPC_Decode, 177, 8, 200, 1, // Opcode: SUB16df
/* 9923 */    MCD::OPC_FilterValue, 1, 218, 9, 0, // Skip to: 12450
/* 9928 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9931 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9941
/* 9936 */    MCD::OPC_Decode, 182, 8, 201, 1, // Opcode: SUB16dq
/* 9941 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9958
/* 9946 */    MCD::OPC_CheckField, 24, 4, 8, 193, 9, 0, // Skip to: 12450
/* 9953 */    MCD::OPC_Decode, 180, 8, 202, 1, // Opcode: SUB16dk
/* 9958 */    MCD::OPC_FilterValue, 4, 183, 9, 0, // Skip to: 12450
/* 9963 */    MCD::OPC_Decode, 178, 8, 201, 1, // Opcode: SUB16di
/* 9968 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 9990
/* 9973 */    MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 9985
/* 9980 */    MCD::OPC_Decode, 197, 8, 203, 1, // Opcode: SUB32dd
/* 9985 */    MCD::OPC_Decode, 204, 8, 204, 1, // Opcode: SUB32dr
/* 9990 */    MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 10007
/* 9995 */    MCD::OPC_CheckField, 3, 1, 0, 144, 9, 0, // Skip to: 12450
/* 10002 */   MCD::OPC_Decode, 200, 8, 205, 1, // Opcode: SUB32dj
/* 10007 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 10024
/* 10012 */   MCD::OPC_CheckField, 3, 1, 1, 127, 9, 0, // Skip to: 12450
/* 10019 */   MCD::OPC_Decode, 202, 8, 206, 1, // Opcode: SUB32dp
/* 10024 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 10094
/* 10029 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10032 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10049
/* 10037 */   MCD::OPC_CheckField, 24, 4, 8, 102, 9, 0, // Skip to: 12450
/* 10044 */   MCD::OPC_Decode, 198, 8, 207, 1, // Opcode: SUB32df
/* 10049 */   MCD::OPC_FilterValue, 1, 92, 9, 0, // Skip to: 12450
/* 10054 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10057 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10067
/* 10062 */   MCD::OPC_Decode, 203, 8, 208, 1, // Opcode: SUB32dq
/* 10067 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10084
/* 10072 */   MCD::OPC_CheckField, 24, 4, 8, 67, 9, 0, // Skip to: 12450
/* 10079 */   MCD::OPC_Decode, 201, 8, 209, 1, // Opcode: SUB32dk
/* 10084 */   MCD::OPC_FilterValue, 4, 57, 9, 0, // Skip to: 12450
/* 10089 */   MCD::OPC_Decode, 199, 8, 210, 1, // Opcode: SUB32di
/* 10094 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 10111
/* 10099 */   MCD::OPC_CheckField, 3, 1, 0, 40, 9, 0, // Skip to: 12450
/* 10106 */   MCD::OPC_Decode, 226, 8, 189, 1, // Opcode: SUBX8dd
/* 10111 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 10127
/* 10116 */   MCD::OPC_CheckField, 3, 1, 0, 23, 9, 0, // Skip to: 12450
/* 10123 */   MCD::OPC_Decode, 220, 8, 37, // Opcode: SUB8jd
/* 10127 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 10143
/* 10132 */   MCD::OPC_CheckField, 3, 1, 1, 7, 9, 0, // Skip to: 12450
/* 10139 */   MCD::OPC_Decode, 222, 8, 38, // Opcode: SUB8pd
/* 10143 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 10166
/* 10148 */   MCD::OPC_CheckField, 24, 4, 8, 247, 8, 0, // Skip to: 12450
/* 10155 */   MCD::OPC_CheckField, 3, 1, 0, 240, 8, 0, // Skip to: 12450
/* 10162 */   MCD::OPC_Decode, 218, 8, 39, // Opcode: SUB8fd
/* 10166 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 10183
/* 10171 */   MCD::OPC_CheckField, 3, 1, 0, 224, 8, 0, // Skip to: 12450
/* 10178 */   MCD::OPC_Decode, 224, 8, 196, 1, // Opcode: SUBX16dd
/* 10183 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 10200
/* 10188 */   MCD::OPC_CheckField, 3, 1, 0, 207, 8, 0, // Skip to: 12450
/* 10195 */   MCD::OPC_Decode, 186, 8, 212, 1, // Opcode: SUB16jd
/* 10200 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 10217
/* 10205 */   MCD::OPC_CheckField, 3, 1, 1, 190, 8, 0, // Skip to: 12450
/* 10212 */   MCD::OPC_Decode, 188, 8, 213, 1, // Opcode: SUB16pd
/* 10217 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 10241
/* 10222 */   MCD::OPC_CheckField, 24, 4, 8, 173, 8, 0, // Skip to: 12450
/* 10229 */   MCD::OPC_CheckField, 3, 1, 0, 166, 8, 0, // Skip to: 12450
/* 10236 */   MCD::OPC_Decode, 184, 8, 214, 1, // Opcode: SUB16fd
/* 10241 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 10258
/* 10246 */   MCD::OPC_CheckField, 3, 1, 0, 149, 8, 0, // Skip to: 12450
/* 10253 */   MCD::OPC_Decode, 225, 8, 203, 1, // Opcode: SUBX32dd
/* 10258 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 10275
/* 10263 */   MCD::OPC_CheckField, 3, 1, 0, 132, 8, 0, // Skip to: 12450
/* 10270 */   MCD::OPC_Decode, 207, 8, 215, 1, // Opcode: SUB32jd
/* 10275 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 10292
/* 10280 */   MCD::OPC_CheckField, 3, 1, 1, 115, 8, 0, // Skip to: 12450
/* 10287 */   MCD::OPC_Decode, 209, 8, 216, 1, // Opcode: SUB32pd
/* 10292 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 10316
/* 10297 */   MCD::OPC_CheckField, 24, 4, 8, 98, 8, 0, // Skip to: 12450
/* 10304 */   MCD::OPC_CheckField, 3, 1, 0, 91, 8, 0, // Skip to: 12450
/* 10311 */   MCD::OPC_Decode, 205, 8, 217, 1, // Opcode: SUB32fd
/* 10316 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 10326
/* 10321 */   MCD::OPC_Decode, 196, 8, 218, 1, // Opcode: SUB32ar
/* 10326 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 10343
/* 10331 */   MCD::OPC_CheckField, 3, 1, 0, 64, 8, 0, // Skip to: 12450
/* 10338 */   MCD::OPC_Decode, 192, 8, 219, 1, // Opcode: SUB32aj
/* 10343 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 10360
/* 10348 */   MCD::OPC_CheckField, 3, 1, 1, 47, 8, 0, // Skip to: 12450
/* 10355 */   MCD::OPC_Decode, 194, 8, 220, 1, // Opcode: SUB32ap
/* 10360 */   MCD::OPC_FilterValue, 31, 37, 8, 0, // Skip to: 12450
/* 10365 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10368 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10385
/* 10373 */   MCD::OPC_CheckField, 24, 4, 8, 22, 8, 0, // Skip to: 12450
/* 10380 */   MCD::OPC_Decode, 190, 8, 221, 1, // Opcode: SUB32af
/* 10385 */   MCD::OPC_FilterValue, 1, 12, 8, 0, // Skip to: 12450
/* 10390 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10393 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10403
/* 10398 */   MCD::OPC_Decode, 195, 8, 222, 1, // Opcode: SUB32aq
/* 10403 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10420
/* 10408 */   MCD::OPC_CheckField, 24, 4, 8, 243, 7, 0, // Skip to: 12450
/* 10415 */   MCD::OPC_Decode, 193, 8, 223, 1, // Opcode: SUB32ak
/* 10420 */   MCD::OPC_FilterValue, 4, 233, 7, 0, // Skip to: 12450
/* 10425 */   MCD::OPC_Decode, 191, 8, 224, 1, // Opcode: SUB32ai
/* 10430 */   MCD::OPC_FilterValue, 11, 100, 1, 0, // Skip to: 10791
/* 10435 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10438 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10448
/* 10443 */   MCD::OPC_Decode, 243, 3, 225, 1, // Opcode: CMP8dd
/* 10448 */   MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 10464
/* 10453 */   MCD::OPC_CheckField, 3, 1, 0, 198, 7, 0, // Skip to: 12450
/* 10460 */   MCD::OPC_Decode, 246, 3, 43, // Opcode: CMP8dj
/* 10464 */   MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 10480
/* 10469 */   MCD::OPC_CheckField, 3, 1, 1, 182, 7, 0, // Skip to: 12450
/* 10476 */   MCD::OPC_Decode, 248, 3, 44, // Opcode: CMP8dp
/* 10480 */   MCD::OPC_FilterValue, 3, 52, 0, 0, // Skip to: 10537
/* 10485 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10488 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 10504
/* 10493 */   MCD::OPC_CheckField, 24, 4, 8, 158, 7, 0, // Skip to: 12450
/* 10500 */   MCD::OPC_Decode, 244, 3, 45, // Opcode: CMP8df
/* 10504 */   MCD::OPC_FilterValue, 1, 149, 7, 0, // Skip to: 12450
/* 10509 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10512 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 10521
/* 10517 */   MCD::OPC_Decode, 249, 3, 47, // Opcode: CMP8dq
/* 10521 */   MCD::OPC_FilterValue, 3, 132, 7, 0, // Skip to: 12450
/* 10526 */   MCD::OPC_CheckField, 24, 4, 8, 125, 7, 0, // Skip to: 12450
/* 10533 */   MCD::OPC_Decode, 247, 3, 48, // Opcode: CMP8dk
/* 10537 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 10547
/* 10542 */   MCD::OPC_Decode, 223, 3, 226, 1, // Opcode: CMP16dr
/* 10547 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 10564
/* 10552 */   MCD::OPC_CheckField, 3, 1, 0, 99, 7, 0, // Skip to: 12450
/* 10559 */   MCD::OPC_Decode, 219, 3, 151, 1, // Opcode: CMP16dj
/* 10564 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 10581
/* 10569 */   MCD::OPC_CheckField, 3, 1, 1, 82, 7, 0, // Skip to: 12450
/* 10576 */   MCD::OPC_Decode, 221, 3, 154, 1, // Opcode: CMP16dp
/* 10581 */   MCD::OPC_FilterValue, 7, 55, 0, 0, // Skip to: 10641
/* 10586 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10589 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10606
/* 10594 */   MCD::OPC_CheckField, 24, 4, 8, 57, 7, 0, // Skip to: 12450
/* 10601 */   MCD::OPC_Decode, 217, 3, 157, 1, // Opcode: CMP16df
/* 10606 */   MCD::OPC_FilterValue, 1, 47, 7, 0, // Skip to: 12450
/* 10611 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10614 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10624
/* 10619 */   MCD::OPC_Decode, 222, 3, 163, 1, // Opcode: CMP16dq
/* 10624 */   MCD::OPC_FilterValue, 3, 29, 7, 0, // Skip to: 12450
/* 10629 */   MCD::OPC_CheckField, 24, 4, 8, 22, 7, 0, // Skip to: 12450
/* 10636 */   MCD::OPC_Decode, 220, 3, 166, 1, // Opcode: CMP16dk
/* 10641 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 10651
/* 10646 */   MCD::OPC_Decode, 236, 3, 227, 1, // Opcode: CMP32dr
/* 10651 */   MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 10667
/* 10656 */   MCD::OPC_CheckField, 3, 1, 0, 251, 6, 0, // Skip to: 12450
/* 10663 */   MCD::OPC_Decode, 232, 3, 110, // Opcode: CMP32dj
/* 10667 */   MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 10683
/* 10672 */   MCD::OPC_CheckField, 3, 1, 1, 235, 6, 0, // Skip to: 12450
/* 10679 */   MCD::OPC_Decode, 234, 3, 111, // Opcode: CMP32dp
/* 10683 */   MCD::OPC_FilterValue, 11, 52, 0, 0, // Skip to: 10740
/* 10688 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10691 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 10707
/* 10696 */   MCD::OPC_CheckField, 24, 4, 8, 211, 6, 0, // Skip to: 12450
/* 10703 */   MCD::OPC_Decode, 230, 3, 113, // Opcode: CMP32df
/* 10707 */   MCD::OPC_FilterValue, 1, 202, 6, 0, // Skip to: 12450
/* 10712 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10715 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 10724
/* 10720 */   MCD::OPC_Decode, 235, 3, 117, // Opcode: CMP32dq
/* 10724 */   MCD::OPC_FilterValue, 3, 185, 6, 0, // Skip to: 12450
/* 10729 */   MCD::OPC_CheckField, 24, 4, 8, 178, 6, 0, // Skip to: 12450
/* 10736 */   MCD::OPC_Decode, 233, 3, 119, // Opcode: CMP32dk
/* 10740 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 10757
/* 10745 */   MCD::OPC_CheckField, 3, 1, 0, 162, 6, 0, // Skip to: 12450
/* 10752 */   MCD::OPC_Decode, 235, 8, 228, 1, // Opcode: XOR8dd
/* 10757 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 10774
/* 10762 */   MCD::OPC_CheckField, 3, 1, 0, 145, 6, 0, // Skip to: 12450
/* 10769 */   MCD::OPC_Decode, 231, 8, 229, 1, // Opcode: XOR16dd
/* 10774 */   MCD::OPC_FilterValue, 24, 135, 6, 0, // Skip to: 12450
/* 10779 */   MCD::OPC_CheckField, 3, 1, 0, 128, 6, 0, // Skip to: 12450
/* 10786 */   MCD::OPC_Decode, 233, 8, 230, 1, // Opcode: XOR32dd
/* 10791 */   MCD::OPC_FilterValue, 12, 110, 2, 0, // Skip to: 11418
/* 10796 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10799 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10816
/* 10804 */   MCD::OPC_CheckField, 3, 1, 0, 103, 6, 0, // Skip to: 12450
/* 10811 */   MCD::OPC_Decode, 147, 3, 189, 1, // Opcode: AND8dd
/* 10816 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 10833
/* 10821 */   MCD::OPC_CheckField, 3, 1, 0, 86, 6, 0, // Skip to: 12450
/* 10828 */   MCD::OPC_Decode, 150, 3, 190, 1, // Opcode: AND8dj
/* 10833 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 10850
/* 10838 */   MCD::OPC_CheckField, 3, 1, 1, 69, 6, 0, // Skip to: 12450
/* 10845 */   MCD::OPC_Decode, 152, 3, 191, 1, // Opcode: AND8dp
/* 10850 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 10927
/* 10855 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10858 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10875
/* 10863 */   MCD::OPC_CheckField, 24, 4, 8, 44, 6, 0, // Skip to: 12450
/* 10870 */   MCD::OPC_Decode, 148, 3, 192, 1, // Opcode: AND8df
/* 10875 */   MCD::OPC_FilterValue, 1, 34, 6, 0, // Skip to: 12450
/* 10880 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10883 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10893
/* 10888 */   MCD::OPC_Decode, 153, 3, 193, 1, // Opcode: AND8dq
/* 10893 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10910
/* 10898 */   MCD::OPC_CheckField, 24, 4, 8, 9, 6, 0, // Skip to: 12450
/* 10905 */   MCD::OPC_Decode, 151, 3, 194, 1, // Opcode: AND8dk
/* 10910 */   MCD::OPC_FilterValue, 4, 255, 5, 0, // Skip to: 12450
/* 10915 */   MCD::OPC_CheckField, 24, 8, 0, 248, 5, 0, // Skip to: 12450
/* 10922 */   MCD::OPC_Decode, 149, 3, 195, 1, // Opcode: AND8di
/* 10927 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 10949
/* 10932 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10944
/* 10939 */   MCD::OPC_Decode, 247, 2, 196, 1, // Opcode: AND16dd
/* 10944 */   MCD::OPC_Decode, 254, 2, 197, 1, // Opcode: AND16dr
/* 10949 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 10966
/* 10954 */   MCD::OPC_CheckField, 3, 1, 0, 209, 5, 0, // Skip to: 12450
/* 10961 */   MCD::OPC_Decode, 250, 2, 198, 1, // Opcode: AND16dj
/* 10966 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 10983
/* 10971 */   MCD::OPC_CheckField, 3, 1, 1, 192, 5, 0, // Skip to: 12450
/* 10978 */   MCD::OPC_Decode, 252, 2, 199, 1, // Opcode: AND16dp
/* 10983 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 11053
/* 10988 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10991 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11008
/* 10996 */   MCD::OPC_CheckField, 24, 4, 8, 167, 5, 0, // Skip to: 12450
/* 11003 */   MCD::OPC_Decode, 248, 2, 200, 1, // Opcode: AND16df
/* 11008 */   MCD::OPC_FilterValue, 1, 157, 5, 0, // Skip to: 12450
/* 11013 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11016 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11026
/* 11021 */   MCD::OPC_Decode, 253, 2, 201, 1, // Opcode: AND16dq
/* 11026 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11043
/* 11031 */   MCD::OPC_CheckField, 24, 4, 8, 132, 5, 0, // Skip to: 12450
/* 11038 */   MCD::OPC_Decode, 251, 2, 202, 1, // Opcode: AND16dk
/* 11043 */   MCD::OPC_FilterValue, 4, 122, 5, 0, // Skip to: 12450
/* 11048 */   MCD::OPC_Decode, 249, 2, 201, 1, // Opcode: AND16di
/* 11053 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 11075
/* 11058 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11070
/* 11065 */   MCD::OPC_Decode, 133, 3, 203, 1, // Opcode: AND32dd
/* 11070 */   MCD::OPC_Decode, 140, 3, 204, 1, // Opcode: AND32dr
/* 11075 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 11092
/* 11080 */   MCD::OPC_CheckField, 3, 1, 0, 83, 5, 0, // Skip to: 12450
/* 11087 */   MCD::OPC_Decode, 136, 3, 205, 1, // Opcode: AND32dj
/* 11092 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 11109
/* 11097 */   MCD::OPC_CheckField, 3, 1, 1, 66, 5, 0, // Skip to: 12450
/* 11104 */   MCD::OPC_Decode, 138, 3, 206, 1, // Opcode: AND32dp
/* 11109 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 11179
/* 11114 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11117 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11134
/* 11122 */   MCD::OPC_CheckField, 24, 4, 8, 41, 5, 0, // Skip to: 12450
/* 11129 */   MCD::OPC_Decode, 134, 3, 207, 1, // Opcode: AND32df
/* 11134 */   MCD::OPC_FilterValue, 1, 31, 5, 0, // Skip to: 12450
/* 11139 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11142 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11152
/* 11147 */   MCD::OPC_Decode, 139, 3, 208, 1, // Opcode: AND32dq
/* 11152 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11169
/* 11157 */   MCD::OPC_CheckField, 24, 4, 8, 6, 5, 0, // Skip to: 12450
/* 11164 */   MCD::OPC_Decode, 137, 3, 209, 1, // Opcode: AND32dk
/* 11169 */   MCD::OPC_FilterValue, 4, 252, 4, 0, // Skip to: 12450
/* 11174 */   MCD::OPC_Decode, 135, 3, 210, 1, // Opcode: AND32di
/* 11179 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 11196
/* 11184 */   MCD::OPC_CheckField, 3, 1, 0, 235, 4, 0, // Skip to: 12450
/* 11191 */   MCD::OPC_Decode, 229, 8, 211, 1, // Opcode: UMULd32d16
/* 11196 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 11213
/* 11201 */   MCD::OPC_CheckField, 0, 4, 12, 218, 4, 0, // Skip to: 12450
/* 11208 */   MCD::OPC_Decode, 230, 8, 208, 1, // Opcode: UMULd32i16
/* 11213 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 11229
/* 11218 */   MCD::OPC_CheckField, 3, 1, 0, 201, 4, 0, // Skip to: 12450
/* 11225 */   MCD::OPC_Decode, 156, 3, 37, // Opcode: AND8jd
/* 11229 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 11245
/* 11234 */   MCD::OPC_CheckField, 3, 1, 1, 185, 4, 0, // Skip to: 12450
/* 11241 */   MCD::OPC_Decode, 158, 3, 38, // Opcode: AND8pd
/* 11245 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 11268
/* 11250 */   MCD::OPC_CheckField, 24, 4, 8, 169, 4, 0, // Skip to: 12450
/* 11257 */   MCD::OPC_CheckField, 3, 1, 0, 162, 4, 0, // Skip to: 12450
/* 11264 */   MCD::OPC_Decode, 154, 3, 39, // Opcode: AND8fd
/* 11268 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 11285
/* 11273 */   MCD::OPC_CheckField, 3, 1, 0, 146, 4, 0, // Skip to: 12450
/* 11280 */   MCD::OPC_Decode, 129, 3, 212, 1, // Opcode: AND16jd
/* 11285 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 11302
/* 11290 */   MCD::OPC_CheckField, 3, 1, 1, 129, 4, 0, // Skip to: 12450
/* 11297 */   MCD::OPC_Decode, 131, 3, 213, 1, // Opcode: AND16pd
/* 11302 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 11326
/* 11307 */   MCD::OPC_CheckField, 24, 4, 8, 112, 4, 0, // Skip to: 12450
/* 11314 */   MCD::OPC_CheckField, 3, 1, 0, 105, 4, 0, // Skip to: 12450
/* 11321 */   MCD::OPC_Decode, 255, 2, 214, 1, // Opcode: AND16fd
/* 11326 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 11343
/* 11331 */   MCD::OPC_CheckField, 3, 1, 0, 88, 4, 0, // Skip to: 12450
/* 11338 */   MCD::OPC_Decode, 143, 3, 215, 1, // Opcode: AND32jd
/* 11343 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 11360
/* 11348 */   MCD::OPC_CheckField, 3, 1, 1, 71, 4, 0, // Skip to: 12450
/* 11355 */   MCD::OPC_Decode, 145, 3, 216, 1, // Opcode: AND32pd
/* 11360 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 11384
/* 11365 */   MCD::OPC_CheckField, 24, 4, 8, 54, 4, 0, // Skip to: 12450
/* 11372 */   MCD::OPC_CheckField, 3, 1, 0, 47, 4, 0, // Skip to: 12450
/* 11379 */   MCD::OPC_Decode, 141, 3, 217, 1, // Opcode: AND32fd
/* 11384 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 11401
/* 11389 */   MCD::OPC_CheckField, 3, 1, 0, 30, 4, 0, // Skip to: 12450
/* 11396 */   MCD::OPC_Decode, 174, 8, 211, 1, // Opcode: SMULd32d16
/* 11401 */   MCD::OPC_FilterValue, 31, 20, 4, 0, // Skip to: 12450
/* 11406 */   MCD::OPC_CheckField, 0, 4, 12, 13, 4, 0, // Skip to: 12450
/* 11413 */   MCD::OPC_Decode, 175, 8, 208, 1, // Opcode: SMULd32i16
/* 11418 */   MCD::OPC_FilterValue, 13, 207, 2, 0, // Skip to: 12142
/* 11423 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11426 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11443
/* 11431 */   MCD::OPC_CheckField, 3, 1, 0, 244, 3, 0, // Skip to: 12450
/* 11438 */   MCD::OPC_Decode, 231, 2, 189, 1, // Opcode: ADD8dd
/* 11443 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 11460
/* 11448 */   MCD::OPC_CheckField, 3, 1, 0, 227, 3, 0, // Skip to: 12450
/* 11455 */   MCD::OPC_Decode, 234, 2, 190, 1, // Opcode: ADD8dj
/* 11460 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 11477
/* 11465 */   MCD::OPC_CheckField, 3, 1, 1, 210, 3, 0, // Skip to: 12450
/* 11472 */   MCD::OPC_Decode, 236, 2, 191, 1, // Opcode: ADD8dp
/* 11477 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 11554
/* 11482 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11485 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11502
/* 11490 */   MCD::OPC_CheckField, 24, 4, 8, 185, 3, 0, // Skip to: 12450
/* 11497 */   MCD::OPC_Decode, 232, 2, 192, 1, // Opcode: ADD8df
/* 11502 */   MCD::OPC_FilterValue, 1, 175, 3, 0, // Skip to: 12450
/* 11507 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11510 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11520
/* 11515 */   MCD::OPC_Decode, 237, 2, 193, 1, // Opcode: ADD8dq
/* 11520 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11537
/* 11525 */   MCD::OPC_CheckField, 24, 4, 8, 150, 3, 0, // Skip to: 12450
/* 11532 */   MCD::OPC_Decode, 235, 2, 194, 1, // Opcode: ADD8dk
/* 11537 */   MCD::OPC_FilterValue, 4, 140, 3, 0, // Skip to: 12450
/* 11542 */   MCD::OPC_CheckField, 24, 8, 0, 133, 3, 0, // Skip to: 12450
/* 11549 */   MCD::OPC_Decode, 233, 2, 195, 1, // Opcode: ADD8di
/* 11554 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 11576
/* 11559 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11571
/* 11566 */   MCD::OPC_Decode, 196, 2, 196, 1, // Opcode: ADD16dd
/* 11571 */   MCD::OPC_Decode, 203, 2, 197, 1, // Opcode: ADD16dr
/* 11576 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 11593
/* 11581 */   MCD::OPC_CheckField, 3, 1, 0, 94, 3, 0, // Skip to: 12450
/* 11588 */   MCD::OPC_Decode, 199, 2, 198, 1, // Opcode: ADD16dj
/* 11593 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11610
/* 11598 */   MCD::OPC_CheckField, 3, 1, 1, 77, 3, 0, // Skip to: 12450
/* 11605 */   MCD::OPC_Decode, 201, 2, 199, 1, // Opcode: ADD16dp
/* 11610 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 11680
/* 11615 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11618 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11635
/* 11623 */   MCD::OPC_CheckField, 24, 4, 8, 52, 3, 0, // Skip to: 12450
/* 11630 */   MCD::OPC_Decode, 197, 2, 200, 1, // Opcode: ADD16df
/* 11635 */   MCD::OPC_FilterValue, 1, 42, 3, 0, // Skip to: 12450
/* 11640 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11643 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11653
/* 11648 */   MCD::OPC_Decode, 202, 2, 201, 1, // Opcode: ADD16dq
/* 11653 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11670
/* 11658 */   MCD::OPC_CheckField, 24, 4, 8, 17, 3, 0, // Skip to: 12450
/* 11665 */   MCD::OPC_Decode, 200, 2, 202, 1, // Opcode: ADD16dk
/* 11670 */   MCD::OPC_FilterValue, 4, 7, 3, 0, // Skip to: 12450
/* 11675 */   MCD::OPC_Decode, 198, 2, 201, 1, // Opcode: ADD16di
/* 11680 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 11702
/* 11685 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11697
/* 11692 */   MCD::OPC_Decode, 217, 2, 203, 1, // Opcode: ADD32dd
/* 11697 */   MCD::OPC_Decode, 224, 2, 204, 1, // Opcode: ADD32dr
/* 11702 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 11719
/* 11707 */   MCD::OPC_CheckField, 3, 1, 0, 224, 2, 0, // Skip to: 12450
/* 11714 */   MCD::OPC_Decode, 220, 2, 205, 1, // Opcode: ADD32dj
/* 11719 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 11736
/* 11724 */   MCD::OPC_CheckField, 3, 1, 1, 207, 2, 0, // Skip to: 12450
/* 11731 */   MCD::OPC_Decode, 222, 2, 206, 1, // Opcode: ADD32dp
/* 11736 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 11806
/* 11741 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11744 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11761
/* 11749 */   MCD::OPC_CheckField, 24, 4, 8, 182, 2, 0, // Skip to: 12450
/* 11756 */   MCD::OPC_Decode, 218, 2, 207, 1, // Opcode: ADD32df
/* 11761 */   MCD::OPC_FilterValue, 1, 172, 2, 0, // Skip to: 12450
/* 11766 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11769 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11779
/* 11774 */   MCD::OPC_Decode, 223, 2, 208, 1, // Opcode: ADD32dq
/* 11779 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11796
/* 11784 */   MCD::OPC_CheckField, 24, 4, 8, 147, 2, 0, // Skip to: 12450
/* 11791 */   MCD::OPC_Decode, 221, 2, 209, 1, // Opcode: ADD32dk
/* 11796 */   MCD::OPC_FilterValue, 4, 137, 2, 0, // Skip to: 12450
/* 11801 */   MCD::OPC_Decode, 219, 2, 210, 1, // Opcode: ADD32di
/* 11806 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 11823
/* 11811 */   MCD::OPC_CheckField, 3, 1, 0, 120, 2, 0, // Skip to: 12450
/* 11818 */   MCD::OPC_Decode, 246, 2, 189, 1, // Opcode: ADDX8dd
/* 11823 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 11839
/* 11828 */   MCD::OPC_CheckField, 3, 1, 0, 103, 2, 0, // Skip to: 12450
/* 11835 */   MCD::OPC_Decode, 240, 2, 37, // Opcode: ADD8jd
/* 11839 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 11855
/* 11844 */   MCD::OPC_CheckField, 3, 1, 1, 87, 2, 0, // Skip to: 12450
/* 11851 */   MCD::OPC_Decode, 242, 2, 38, // Opcode: ADD8pd
/* 11855 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 11878
/* 11860 */   MCD::OPC_CheckField, 24, 4, 8, 71, 2, 0, // Skip to: 12450
/* 11867 */   MCD::OPC_CheckField, 3, 1, 0, 64, 2, 0, // Skip to: 12450
/* 11874 */   MCD::OPC_Decode, 238, 2, 39, // Opcode: ADD8fd
/* 11878 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 11895
/* 11883 */   MCD::OPC_CheckField, 3, 1, 0, 48, 2, 0, // Skip to: 12450
/* 11890 */   MCD::OPC_Decode, 244, 2, 196, 1, // Opcode: ADDX16dd
/* 11895 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 11912
/* 11900 */   MCD::OPC_CheckField, 3, 1, 0, 31, 2, 0, // Skip to: 12450
/* 11907 */   MCD::OPC_Decode, 206, 2, 212, 1, // Opcode: ADD16jd
/* 11912 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 11929
/* 11917 */   MCD::OPC_CheckField, 3, 1, 1, 14, 2, 0, // Skip to: 12450
/* 11924 */   MCD::OPC_Decode, 208, 2, 213, 1, // Opcode: ADD16pd
/* 11929 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 11953
/* 11934 */   MCD::OPC_CheckField, 24, 4, 8, 253, 1, 0, // Skip to: 12450
/* 11941 */   MCD::OPC_CheckField, 3, 1, 0, 246, 1, 0, // Skip to: 12450
/* 11948 */   MCD::OPC_Decode, 204, 2, 214, 1, // Opcode: ADD16fd
/* 11953 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 11970
/* 11958 */   MCD::OPC_CheckField, 3, 1, 0, 229, 1, 0, // Skip to: 12450
/* 11965 */   MCD::OPC_Decode, 245, 2, 203, 1, // Opcode: ADDX32dd
/* 11970 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 11987
/* 11975 */   MCD::OPC_CheckField, 3, 1, 0, 212, 1, 0, // Skip to: 12450
/* 11982 */   MCD::OPC_Decode, 227, 2, 215, 1, // Opcode: ADD32jd
/* 11987 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 12004
/* 11992 */   MCD::OPC_CheckField, 3, 1, 1, 195, 1, 0, // Skip to: 12450
/* 11999 */   MCD::OPC_Decode, 229, 2, 216, 1, // Opcode: ADD32pd
/* 12004 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 12028
/* 12009 */   MCD::OPC_CheckField, 24, 4, 8, 178, 1, 0, // Skip to: 12450
/* 12016 */   MCD::OPC_CheckField, 3, 1, 0, 171, 1, 0, // Skip to: 12450
/* 12023 */   MCD::OPC_Decode, 225, 2, 217, 1, // Opcode: ADD32fd
/* 12028 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 12038
/* 12033 */   MCD::OPC_Decode, 216, 2, 218, 1, // Opcode: ADD32ar
/* 12038 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 12055
/* 12043 */   MCD::OPC_CheckField, 3, 1, 0, 144, 1, 0, // Skip to: 12450
/* 12050 */   MCD::OPC_Decode, 212, 2, 219, 1, // Opcode: ADD32aj
/* 12055 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 12072
/* 12060 */   MCD::OPC_CheckField, 3, 1, 1, 127, 1, 0, // Skip to: 12450
/* 12067 */   MCD::OPC_Decode, 214, 2, 220, 1, // Opcode: ADD32ap
/* 12072 */   MCD::OPC_FilterValue, 31, 117, 1, 0, // Skip to: 12450
/* 12077 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12080 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12097
/* 12085 */   MCD::OPC_CheckField, 24, 4, 8, 102, 1, 0, // Skip to: 12450
/* 12092 */   MCD::OPC_Decode, 210, 2, 221, 1, // Opcode: ADD32af
/* 12097 */   MCD::OPC_FilterValue, 1, 92, 1, 0, // Skip to: 12450
/* 12102 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12105 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12115
/* 12110 */   MCD::OPC_Decode, 215, 2, 222, 1, // Opcode: ADD32aq
/* 12115 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12132
/* 12120 */   MCD::OPC_CheckField, 24, 4, 8, 67, 1, 0, // Skip to: 12450
/* 12127 */   MCD::OPC_Decode, 213, 2, 223, 1, // Opcode: ADD32ak
/* 12132 */   MCD::OPC_FilterValue, 4, 57, 1, 0, // Skip to: 12450
/* 12137 */   MCD::OPC_Decode, 211, 2, 224, 1, // Opcode: ADD32ai
/* 12142 */   MCD::OPC_FilterValue, 14, 47, 1, 0, // Skip to: 12450
/* 12147 */   MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 12150 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 12160
/* 12155 */   MCD::OPC_Decode, 165, 3, 231, 1, // Opcode: ASR8di
/* 12160 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12170
/* 12165 */   MCD::OPC_Decode, 140, 4, 231, 1, // Opcode: LSR8di
/* 12170 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 12180
/* 12175 */   MCD::OPC_Decode, 244, 7, 231, 1, // Opcode: ROR8di
/* 12180 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 12190
/* 12185 */   MCD::OPC_Decode, 164, 3, 228, 1, // Opcode: ASR8dd
/* 12190 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 12200
/* 12195 */   MCD::OPC_Decode, 139, 4, 228, 1, // Opcode: LSR8dd
/* 12200 */   MCD::OPC_FilterValue, 7, 5, 0, 0, // Skip to: 12210
/* 12205 */   MCD::OPC_Decode, 243, 7, 228, 1, // Opcode: ROR8dd
/* 12210 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 12220
/* 12215 */   MCD::OPC_Decode, 161, 3, 232, 1, // Opcode: ASR16di
/* 12220 */   MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 12230
/* 12225 */   MCD::OPC_Decode, 136, 4, 232, 1, // Opcode: LSR16di
/* 12230 */   MCD::OPC_FilterValue, 11, 5, 0, 0, // Skip to: 12240
/* 12235 */   MCD::OPC_Decode, 240, 7, 232, 1, // Opcode: ROR16di
/* 12240 */   MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 12250
/* 12245 */   MCD::OPC_Decode, 160, 3, 229, 1, // Opcode: ASR16dd
/* 12250 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 12260
/* 12255 */   MCD::OPC_Decode, 135, 4, 229, 1, // Opcode: LSR16dd
/* 12260 */   MCD::OPC_FilterValue, 15, 5, 0, 0, // Skip to: 12270
/* 12265 */   MCD::OPC_Decode, 239, 7, 229, 1, // Opcode: ROR16dd
/* 12270 */   MCD::OPC_FilterValue, 16, 5, 0, 0, // Skip to: 12280
/* 12275 */   MCD::OPC_Decode, 163, 3, 233, 1, // Opcode: ASR32di
/* 12280 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 12290
/* 12285 */   MCD::OPC_Decode, 138, 4, 233, 1, // Opcode: LSR32di
/* 12290 */   MCD::OPC_FilterValue, 19, 5, 0, 0, // Skip to: 12300
/* 12295 */   MCD::OPC_Decode, 242, 7, 233, 1, // Opcode: ROR32di
/* 12300 */   MCD::OPC_FilterValue, 20, 5, 0, 0, // Skip to: 12310
/* 12305 */   MCD::OPC_Decode, 162, 3, 230, 1, // Opcode: ASR32dd
/* 12310 */   MCD::OPC_FilterValue, 21, 5, 0, 0, // Skip to: 12320
/* 12315 */   MCD::OPC_Decode, 137, 4, 230, 1, // Opcode: LSR32dd
/* 12320 */   MCD::OPC_FilterValue, 23, 5, 0, 0, // Skip to: 12330
/* 12325 */   MCD::OPC_Decode, 241, 7, 230, 1, // Opcode: ROR32dd
/* 12330 */   MCD::OPC_FilterValue, 33, 5, 0, 0, // Skip to: 12340
/* 12335 */   MCD::OPC_Decode, 173, 8, 231, 1, // Opcode: SHL8di
/* 12340 */   MCD::OPC_FilterValue, 35, 5, 0, 0, // Skip to: 12350
/* 12345 */   MCD::OPC_Decode, 238, 7, 231, 1, // Opcode: ROL8di
/* 12350 */   MCD::OPC_FilterValue, 37, 5, 0, 0, // Skip to: 12360
/* 12355 */   MCD::OPC_Decode, 172, 8, 228, 1, // Opcode: SHL8dd
/* 12360 */   MCD::OPC_FilterValue, 39, 5, 0, 0, // Skip to: 12370
/* 12365 */   MCD::OPC_Decode, 237, 7, 228, 1, // Opcode: ROL8dd
/* 12370 */   MCD::OPC_FilterValue, 41, 5, 0, 0, // Skip to: 12380
/* 12375 */   MCD::OPC_Decode, 169, 8, 232, 1, // Opcode: SHL16di
/* 12380 */   MCD::OPC_FilterValue, 43, 5, 0, 0, // Skip to: 12390
/* 12385 */   MCD::OPC_Decode, 234, 7, 232, 1, // Opcode: ROL16di
/* 12390 */   MCD::OPC_FilterValue, 45, 5, 0, 0, // Skip to: 12400
/* 12395 */   MCD::OPC_Decode, 168, 8, 229, 1, // Opcode: SHL16dd
/* 12400 */   MCD::OPC_FilterValue, 47, 5, 0, 0, // Skip to: 12410
/* 12405 */   MCD::OPC_Decode, 233, 7, 229, 1, // Opcode: ROL16dd
/* 12410 */   MCD::OPC_FilterValue, 49, 5, 0, 0, // Skip to: 12420
/* 12415 */   MCD::OPC_Decode, 171, 8, 233, 1, // Opcode: SHL32di
/* 12420 */   MCD::OPC_FilterValue, 51, 5, 0, 0, // Skip to: 12430
/* 12425 */   MCD::OPC_Decode, 236, 7, 233, 1, // Opcode: ROL32di
/* 12430 */   MCD::OPC_FilterValue, 53, 5, 0, 0, // Skip to: 12440
/* 12435 */   MCD::OPC_Decode, 170, 8, 230, 1, // Opcode: SHL32dd
/* 12440 */   MCD::OPC_FilterValue, 55, 5, 0, 0, // Skip to: 12450
/* 12445 */   MCD::OPC_Decode, 235, 7, 230, 1, // Opcode: ROL32dd
/* 12450 */   MCD::OPC_Fail,
  0
};

static const uint8_t InstrLenTable[] = {
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
32,
16,
16,
32,
16,
32,
32,
48,
16,
32,
32,
48,
16,
32,
32,
48,
32,
48,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
48,
16,
32,
32,
64,
32,
32,
16,
32,
32,
32,
16,
48,
32,
48,
48,
48,
80,
32,
48,
16,
32,
32,
32,
16,
64,
48,
64,
64,
64,
64,
16,
32,
32,
16,
32,
32,
32,
48,
32,
48,
48,
48,
16,
16,
16,
48,
32,
32,
32,
32,
16,
16,
16,
16,
16,
16,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
16,
32,
16,
32,
32,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
64,
80,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
80,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
16,
16,
16,
16,
16,
16,
16,
32,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
32,
16,
32,
16,
32,
16,
48,
16,
32,
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  llvm_unreachable("Invalid index!");
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 26:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 28:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 30:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 32:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 48, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 34:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 35:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 32, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 32, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 48, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 32, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 32, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 32, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 112:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 116:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 118:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 123:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 124:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 126:
    tmp = fieldFromInstruction(insn, 48, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 131:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 133:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 135:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 136:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 137:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 138:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 139:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 140:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 141:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 142:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 143:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 144:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 145:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 146:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 147:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 148:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 149:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 150:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 151:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 152:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 153:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 154:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 155:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 156:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 157:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 158:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 159:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 160:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 161:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 162:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 163:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 164:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 165:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 166:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 167:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 168:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 169:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 170:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 171:
    return S;
  case 172:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 173:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 174:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 175:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 176:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 177:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 178:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    if (DecodeCCRCRegisterClass(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 179:
    if (DecodeCCRCRegisterClass(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 180:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 181:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    if (DecodeCCRCRegisterClass(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 182:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    if (DecodeCCRCRegisterClass(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 183:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    if (DecodeCCRCRegisterClass(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 184:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    if (DecodeCCRCRegisterClass(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 185:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    if (DecodeCCRCRegisterClass(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 186:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    if (DecodeCCRCRegisterClass(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 187:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 188:
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 189:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 190:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 191:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 192:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 193:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 194:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 195:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 196:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 197:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 198:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 199:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 200:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 201:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 202:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 203:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 204:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 205:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 206:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 207:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 208:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 209:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 210:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 211:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 212:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 213:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 214:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 215:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 216:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 217:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 218:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 219:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 220:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 221:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 222:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 223:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 224:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeAR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 225:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 226:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeXR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 227:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (DecodeXR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 228:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 229:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 230:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 231:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR8RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 232:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR16RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 233:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (DecodeDR32RegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI,
                                      llvm::function_ref<void(APInt &, uint64_t)> makeUp) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      makeUp(insn, Start + Len);
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      uint64_t Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      makeUp(insn, Start + Len);
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      Len = InstrLenTable[Opc];
      makeUp(insn, Len);
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      uint64_t PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      uint64_t NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
